

# tclfile -*- TCL -*- Created: ramsan Aug-1996, Modified: ramsan Dec-1996
# for tk4.0

proc SetMenusVariables {} {
    global MenuNames MenuEntries MenuCommands MenuAcceler MenuIcons
    global tcl_platform GIDDEFAULT
    global GidPriv
    
    catch { unset MenuNames MenuEntries MenuCommands MenuAcceler MenuIcons }
    
    set MenuNames [list [_ "Files#C#menu"] [_ "View#C#menu,Verb"] [_ "Geometry#C#menu"] [_ "Utilities#C#menu"] [_ "Data#C#menu"] [_ "Mesh#C#menu"] \
	    [_ "Calculate#C#menu"] [_ "Help#C#menu"] ]
    
    #---------------
    
    set MenuEntries(0) [list [_ "New#C#menu"] [_ "Open#C#menu"]... [_ "Save#C#menu"] [_ "Save as#C#menu"]... ---\
	    [_ "Import#C#menu"] [_ "Export#C#menu"] --- [_ "Postprocess#C#menu"] ---\
	    [_ "Print to file#C#menu"] [_ "Page/image setup#C#menu"]... [_ "Print#C#menu"]... \
	    --- [_ "Recent post files#C#menu"] [_ "Recent projects#C#menu"] --- [_ "Quit#C#menu"]]
    
    set MenuCommands(0) {{Files New} {Files Read} \
	    {Files Save} {Files SaveAs} "" "" "" \
	    "" Postprocess "" "" {-np- PageSetup} {-np- HardcopyToPrint {Hardcopy PS}} \
	    "" {-np- AddEntitiesToMenuRecentPostFiles %W } {-np- AddEntitiesToMenuRecentProjects %W } "" Quit }
    
    set MenuAcceler(0) { "Control-x Control-n" Control-o Control-s \
	    "Control-x Control-s" "" "" "" "" "" "" "" "" "" "" "" "" "" Control-q }
    set MenuIcons(0) {"new16x16.gif" "open16x16.gif" "save16x16.gif" "" "" "" "" "" \
	    "prepost16x16.gif" "" "camera16x16.gif" "" "print16x16.gif" "" "" "" "" "exit16x16.gif" }
    
    set MenuEntries(0,5) [list [_ "IGES#C#menu"]... [_ "DXF#C#menu"]... [_ "Parasolid#C#menu"]... [_ "ACIS#C#menu"]... \
	    [_ "VDA#C#menu"]... [_ "Rhino#C#menu"]... [_ "Shapefile#C#menu"]... ---  [_ "NASTRAN mesh#C#menu"]... \
	    [_ "STL mesh#C#menu"]... [_ "VRML mesh#C#menu"]... [_ "3DStudio mesh#C#menu"]... [_ "CGNS mesh#C#menu"]...\
	    [_ "GiD mesh#C#menu"]... [_ "Surface mesh#C#menu"]... [_ "VTK Voxels#C#menu"]... \
	    ---  [_ "Batch file#C#menu"]... [_ "Insert GiD geometry#C#menu"]... ]
    
    set MenuCommands(0,5) { {Files IgesRead} {Files DxfRead} {Files ParasolidRead} {Files AcisRead}\
	    {Files VDARead} {Files RhinoRead}  {Files ShapefileRead} "" {Files NASTRANRead} \
	    {Files STLRead} {Files VrmlRead} {Files 3DStudioRead} {Files CGNSRead} {Files MeshRead} \
	    {Files ReadSurfMeshes ReadFromFile} {Files LoadVTKVoxels} "" {Files BatchFile} {Files InsertGeom} }
    
    set MenuAcceler(0,5) { Control-i Control-d "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "Control-b" "" }
    set MenuIcons(0,5) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}
    
    set MenuEntries(0,6) [list [_ "IGES#C#menu"]... [_ "DXF#C#menu"]... [_ "ACIS#C#menu"]... --- [_ "GiD mesh#C#menu"]... --- \
	    [_ "Text data report#C#menu"]...  [_ "ASCII project#C#menu"]... [_ "ON layers#C#menu"]... --- \
	    [_ "Calculation file#C#menu"]... [_ "Using Template .bas (only mesh)#C#menu"]]
    
    set MenuCommands(0,6) { {Files IgesWrite} {Files DxfWrite}  {Files AcisWrite} "" {Files WriteMesh} "" \
	    {Files WriteAscii} {Files SaveAsciiProj} {Files SaveLayer} "" \
	    {Files WriteCalcFile} {-np- SetTemplatesMenu %W }}
    
    set MenuAcceler(0,6) { "" "" "" "" "" "" "" "" "" "" "Control-x Control-c" ""}
    
    set MenuIcons(0,6) {"" "" "" "" "" "" "" "" "" "" "" "" "" }
    
    set MenuEntries(0,6,11) ""
    

    set MenuEntries(0,10) [list [_ "PS/EPS Screen#C#menu"]... [_ "PS/EPS Vectorial#C#menu"]... --- \
	    [_ "BMP#C#menu"]... [_ "GIF#C#menu"]... [_ "JPEG#C#menu"]... [_ "PNG#C#menu"]... [_ "TGA#C#menu"]... [_ "TIFF#C#menu"]... [_ "VRML#C#menu"]...]
    
    set MenuCommands(0,10) { "" "" ""\
	    { -ne- Hardcopy BMP} \
	    { -ne- Hardcopy GIF} \
	    { -ne- Hardcopy JPEG} \
	    { -ne- Hardcopy PNG} \
	    { -ne- Hardcopy TGA} \
	    { -ne- Hardcopy TIFF} \
	    { -ne- Hardcopy VRML} }
    
    set MenuEntries(0,10,0) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommands(0,10,0) { { -ne- Hardcopy Options VectorialPS no escape Hardcopy PS} \
	    { -ne- Hardcopy Options VectorialPS no escape Hardcopy EPS} }
    
    set MenuEntries(0,10,1) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommands(0,10,1) { { -ne- Hardcopy Options VectorialPS yes escape Hardcopy PS } \
	    { -ne- Hardcopy Options VectorialPS yes escape Hardcopy EPS} }
    
    set MenuEntries(0,14) ""
    set MenuEntries(0,15) ""
    
    #--------------
    
    #copyclipboard only available for windows
    set what "PRE"
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntries(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		[_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... [_ "Clip planes#C#menu"]... \
		--- [_ "Label#C#menu"] [_ "Normals#C#menu"] [_ "Higher entities#C#menu"] \
		[_ "Curvatures#C#menu"] --- [_ "View#C#menu,Noun"] [_ "Recent view files#C#menu"] --- \
		                [_ "Background image#C#menu"] \
		[_ "Image to clipboard#C#menu"] [_ "Multiple windows#C#menu"]... \
		--- [_ "Mode#C#menu"]]
	set MenuCommands(1) [list "" "" "" "" \
		{-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} {-np- ClipPlanes} "" \
		"" {-np- AddEntitiesToMenuDrawNormals %W } {-np- AddEntitiesToMenuDrawHigher %W } \
		{-np- AddEntitiesToMenuDrawCurvatures %W } "" \
		"" {-np- AddEntitiesToMenuRecentViewFiles %W } "" \
		                 "" {-ne- hardcopy copyclipboard} \
		"-np- ViewSeveralWindows" "" "-np- ViewModeMenu %W $what" ]
	set MenuAcceler(1) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" }
	set MenuIcons(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" "" "" "" "" \
		"" "" "" "" "" "" }
    } else {
	set MenuEntries(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		[_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... [_ "Clip planes#C#menu"]... \
		--- [_ "Label#C#menu"] [_ "Normals#C#menu"] [_ "Higher entities#C#menu"] \
		[_ "Curvatures#C#menu"] --- [_ "View#C#menu,Noun"] [_ "Recent view files#C#menu"] --- \
		                [_ "Background image#C#menu"] \
		[_ "Multiple windows#C#menu"]... \
		--- [_ "Mode#C#menu"]]
	set MenuCommands(1) [list "" "" "" "" \
		{-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} {-np- ClipPlanes} "" \
		"" {-np- AddEntitiesToMenuDrawNormals %W } {-np- AddEntitiesToMenuDrawHigher %W } \
		{-np- AddEntitiesToMenuDrawCurvatures %W } "" \
		"" ""  {-np- AddEntitiesToMenuRecentViewFiles %W } "" \
		"-np- ViewSeveralWindows" "" "-np- ViewModeMenu %W $what" ]
	set MenuAcceler(1) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" }
	set MenuIcons(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" "" "" \
		"" "" "" "" "" "" "" }
    }
    # invoked to set up accelerators
    ViewModeMenu "" PRE

    set MenuEntries(1,0) [list [_ "In#C#menu"] [_ "Out#C#menu"] --- [_ "Dynamic#C#menu"] [_ "Previous#C#menu"] \
	    [_ "Next#C#menu"] --- [_ "Frame#C#menu"]]
    set MenuCommands(1,0) { {-ne- zoom in} {-ne- zoom out} "" \
	    {-ne- zoom dynamic} \
	    {-ne- zoom previous} {-ne- zoom next} "" {-ne- zoom frame} }
    set MenuIcons(1,0) { "zoomin16x16.gif" "zoomout16x16.gif" "" "" "" "" "" "zframe16x16.gif" }

    set MenuEntries(1,1) [list [_ "Trackball#C#menu"] [_ "Screen axes#C#menu"] [_ "Object axes#C#menu"] \
	    [_ "Center#C#menu"] --- [_ "Plane XY (Original)#C#menu"] [_ "Plane XZ#C#menu"] [_ "Plane YZ#C#menu"] [_ "Isometric#C#menu"]]
    set MenuCommands(1,1) { {-ne- rotate Trackball} {-ne- rotate ScrAxes} \
	    {-ne- rotate ObjAxes}  {-ne- rotate Center FJoin} \
	    "" {-ne- rotate angle 270 90} {-ne- rotate angle 270 0} \
	    {-ne- rotate angle 0 0} {-ne- rotate angle 45 45} }
    set MenuIcons(1,1) { "rotate16x16.gif" "" "" "" "" "" "" "" "" }
    
    set MenuEntries(1,2) [list [_ "Two point#C#menu"] [_ "Dynamic#C#menu"]]
    set MenuCommands(1,2) { {-ne- pan} {-ne- DynamicPan} }
    set MenuIcons(1,2) { "" "pan16x16.gif" }
    
    set MenuEntries(1,5) ""
    set MenuCommands(1,5) ""
    
    set MenuEntries(1,9) [list [_ "All#C#menu"] [_ "All in#C#menu"] [_ "Select#C#menu"] --- [_ "Off#C#menu"]]
    set MenuCommands(1,9) { {-ne- label All} \
	    {-np- AddBitmapsToMenu %W {.central.s process label  } } \
	    {-np- AddBitmapsToMenu %W {.central.s process label Select } } "" \
	    {-ne- label Off} }
    set MenuEntries(1,9,1) {}
    set MenuCommands(1,9,1) {}
    set MenuEntries(1,9,2) {}
    set MenuCommands(1,9,2) {}
   
    set MenuEntries(1,10) ""

    set MenuEntries(1,11) ""
    set MenuEntries(1,12) ""
    
    set MenuEntries(1,14) [list [_ "Save#C#menu"]... [_ "Read#C#menu"]...]
    set MenuCommands(1,14) { {View SaveView} {View ReadView} }
    
    set MenuEntries(1,15) ""
    set MenuCommands(1,15) ""

    set MenuEntries(1,17) [list [_ "Fit screen#C#menu"]... [_ "Real size#C#menu"]...  [_ "Default#C#menu"]]
    set MenuCommands(1,17) { { utilities backgroundimg backgroundimg} \
	    { utilities backgroundimg realsizeimg} { utilities backgroundimg default} }

    #view mode
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntries(1,21) ""
	set MenuCommands(1,21) ""
    } else {
	set MenuEntries(1,20) ""
	set MenuCommands(1,20) ""
    }
    
    #-----------
    
    set MenuEntries(2) [list [_ "View geometry#C#menu"] --- [_ "Create#C#menu"] [_ "Delete#C#menu"] [_ "Edit#C#menu"]]
    set MenuCommands(2) { {MEscape Geometry} "" "" "" ""}
    set MenuAcceler(2) { "" "" "" "" "" }
    set MenuIcons(2) {"" "" "" "erase16x16.gif" "" }

    set MenuEntries(2,2) [list [_ "Point#C#menu"] --- \
	    [_ "Straight line#C#menu"] [_ "NURBS line#C#menu"] [_ "Parametric line#C#menu"]... \
	    [_ "Polyline#C#menu"] [_ "Arc#C#menu"] --- \
	    [_ "NURBS surface#C#menu"] [_ "Parametric surface#C#menu"]... \
	    [_ "Contact surface#C#menu"] [_ "Surface mesh#C#menu"] --- \
	    [_ "Volume#C#menu"] [_ "Contact#C#menu"] --- [_ "Object#C#menu"]]
    set MenuCommands(2,2) " {geometry create point} {} \
	{geometry create line} {geometry create NurbsLine} {-np- ParametricLine} \
	{geometry create polyline} {} {} \
	{} {-np- ParametricSurface} {geometry create contact surface} {geometry create SurfMesh SelectMesh} {} \
	{} {} {} {} "
    set MenuIcons(2,2) { "point16x16.gif" "" "line16x16.gif" "spline16x16.gif" "" "poly16x16.gif" "arc16x16.gif" "" \
	"surface16x16.gif" "" "" "" "" "volume16x16.gif" "" "" "object16x16.gif" }

    set MenuEntries(2,2,6) [list [_ "By 3 points#C#menu"] [_ "Fillet curves#C#menu"]]
    set MenuCommands(2,2,6) "{geometry create arc} {geometry create arc ByTangents}"
    
    set MenuEntries(2,2,8) [list [_ "By contour#C#menu"] [_ "Automatic#C#menu"] [_ "Trimmed#C#menu"] [_ "Untrimmed#C#menu"]\
	    [_ "Parallel Lines#C#menu"] [_ "By Points#C#menu"] [_ "By LinePoints#C#menu"] [_ "Search#C#menu"] ]
    set MenuCommands(2,2,8) { {geometry create NurbsSurface} \
	{geometry create NurbsSurface Automatic} \
	    {geometry create TrimmedNurb} {geometry create UntrimSurf} \
	{geometry create NurbsSurface ParallelLines} \
	    {geometry create NurbsSurface ByPoints} \
	{geometry create NurbsSurface ByLinePoints} \
	    {geometry create NurbsSurface Search} }
    
    set MenuEntries(2,2,13) [list [_ "By contour#C#menu"] [_ "Automatic 6-sided volumes#C#menu"] \
	    [_ "Search#C#menu"] [_ "Hole#C#menu"]]
    set MenuCommands(2,2,13) " {geometry create volume} \
	{geometry create volume AutomaticStruct} \
	{geometry create volume search} {geometry create volume hole}"
	
    set MenuEntries(2,2,14) [list [_ "Volume#C#menu"] [_ "Separated volume#C#menu"]]
    set MenuCommands(2,2,14) { {geometry create contact volume} \
	{geometry create contact SeparatedVolume}} 
    
    set MenuEntries(2,2,16) [list [_ "Rectangle#C#menu"] [_ "Polygon#C#menu"] [_ "Circle#C#menu"] --- [_ "Sphere#C#menu"] [_ "Cylinder#C#menu"] \
	    [_ "Cone#C#menu"] [_ "Prism#C#menu"] [_ "Torus#C#menu"] ]
    set MenuCommands(2,2,16) { {geometry create Object Rectangle } \
	{geometry create Object polygonPNR } \
	{geometry create Object CirclePNR } "" {geometry create Object Sphere } \
	    {geometry create Object Cylinder } {geometry create Object Cone } \
	    {geometry create Object Prism } {geometry create Object Torus} }
 
    
    set MenuEntries(2,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"] \
	    --- [_ "All types#C#menu"]]
    set MenuCommands(2,3) { {geometry delete point} {geometry delete line} \
	    {geometry delete surface} {geometry delete volume} "" \
	    {geometry delete AllTypes} }
    
    set MenuEntries(2,4) [list [_ "Move point#C#menu"] [_ "Divide#C#menu"] [_ "Lines operations#C#menu"] \
	    [_ "Swap arc#C#menu"] [_ "Polyline#C#menu"] [_ "SurfMesh#C#menu"] \
	    --- [_ "Edit NURBS#C#menu"] [_ "Convert to NURBS#C#menu"] [_ "Simplify NURBS#C#menu"] \
	    [_ "Hole NURBS surface#C#menu"] --- [_ "Collapse#C#menu"] [_ "Uncollapse#C#menu"] --- \
	    [_ "Intersection#C#menu"] [_ "Surface boolean op.#C#menu"] [_ "Volume boolean op.#C#menu"]]
    set MenuCommands(2,4) { {geometry edit MovePoint} "" "" \
	{geometry edit swaparc} "" {geometry edit EditSurfMeshes} "" "" "" "" \
	    {geometry edit HoleNurb} "" "" "" "" "" "" ""}
	
    set MenuEntries(2,4,1) [list [_ "Lines#C#menu"] [_ "Polylines#C#menu"] [_ "Surfaces#C#menu"] \
	    [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,1) { "" {geometry edit DivideLine Multiple polyline} "" "" }
    
    set MenuEntries(2,4,1,0) [list [_ "Num Divisions#C#menu"] [_ "Near point#C#menu"] [_ "Parameter#C#menu"] \
	    [_ "Relative Length#C#menu"] [_ "Length#C#menu"]]
    set MenuCommands(2,4,1,0) { {geometry edit DivideLine Multiple NumDivisions } \
	    {geometry edit DivideLine Multiple Point } \
	    {geometry edit DivideLine Multiple Parameter } \
	    {geometry edit DivideLine Multiple RelativeLength } \
	    {geometry edit DivideLine Multiple Measure } }

    set MenuEntries(2,4,1,2) [list [_ "Num Divisions#C#menu"] [_ "Near point#C#menu"] [_ "Parameter#C#menu"] [_ "Split#C#menu"]]
    set MenuCommands(2,4,1,2) { {geometry edit DivideSurf NumDivisions } \
	{geometry edit DivideSurf Point } {geometry edit DivideSurf Parameter } \
	    {Geometry Edit SplitSurf } }
    
    set MenuEntries(2,4,1,3) [list [_ "Split#C#menu"]]
    set MenuCommands(2,4,1,3) { {Geometry Edit SplitVolume } }
    
    set MenuEntries(2,4,2) [list [_ "Join lines end points#C#menu"] [_ "Force to be tangent#C#menu"]]
    set MenuCommands(2,4,2) { {geometry edit JoinLinesExt} {geometry edit TangentNurbsL } }

    set MenuEntries(2,4,4) [list [_ "Explode polyline#C#menu"] [_ "Edit polyline#C#menu"]]
    set MenuCommands(2,4,4) { {geometry edit ExplodePoly} {geometry edit edpoly} }

    set MenuEntries(2,4,7) [list [_ "Line#C#menu"]... [_ "Surface#C#menu"]... ]
    set MenuCommands(2,4,7) { { -np- EditNURBS line } { -np- EditNURBS surface } }

    set MenuEntries(2,4,8) [list [_ "Line#C#menu"] [_ "Surface#C#menu"]]
    set MenuCommands(2,4,8) { {geometry edit ConvToNurbsL} {geometry edit ConvToNurbsS} }

    set MenuEntries(2,4,9) [list [_ "Model#C#menu"] --- [_ "Line#C#menu"] [_ "Surface#C#menu"]]
    set MenuCommands(2,4,9) { {geometry edit SimplifyNurbsS All escape escape escape geometry edit SimplifyNurbsL All} "" \
		{geometry edit SimplifyNurbsL} {geometry edit SimplifyNurbsS} }

    set MenuEntries(2,4,12) [list [_ "Model#C#menu"] --- \
	    [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,12) { {utilities Collapse model} "" {utilities Collapse points} \
	{utilities Collapse lines} {utilities Collapse surfaces} {utilities Collapse volumes} }
    
    set MenuEntries(2,4,13) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(2,4,13) { {Utilities Uncollapse Lines} {Utilities Uncollapse Surfaces} \
	    {Utilities Uncollapse Volumes} }
    
    
    set MenuEntries(2,4,15) [list [_ "Line-line#C#menu"] [_ "Multiple lines#C#menu"] --- \
	    [_ "Surface-2 points#C#menu"] [_ "Surface-lines#C#menu"] [_ "Surface-surface#C#menu"] \
	    [_ "Multiple surfaces#C#menu"] ]
    
    set MenuCommands(2,4,15) { {geometry create IntersectLines}  \
	{geometry create IntMultLines} "" {geometry create IntSurfPnts} \
	{geometry create IntSurfLine} {geometry create IntSurfs} \
	{geometry create IntMultSurfs} }
    
    set MenuEntries(2,4,16) [list [_ "Union#C#menu"] [_ "Intersection#C#menu"] [_ "Substraction#C#menu"] ]
    
    set MenuCommands(2,4,16) " {geometry create IntSolid2D Union} \
	{geometry create IntSolid2D Intersect} \
	{geometry create IntSolid2D Substract} "
    
    set MenuEntries(2,4,17) [list [_ "Union#C#menu"] [_ "Intersection#C#menu"] [_ "Substraction#C#menu"] ]
    
    set MenuCommands(2,4,17) " {geometry create IntSolid3D Union} \
	{geometry create IntSolid3D Intersect} \
	{geometry create IntSolid3D Substract} "
    #--------------

    set MenuEntries(3) [list [_ "Undo#C#menu"]... --- [_ "Preferences#C#menu"]... [_ "Layers#C#menu"]... --- \
	    [_ "Tools#C#menu"] --- [_ "Copy#C#menu"]... [_ "Move#C#menu"]... --- [_ "Status#C#menu"]... [_ "List#C#menu"] \
	    [_ "Renumber#C#menu"] [_ "Id#C#menu"] [_ "Signal#C#menu"] --- [_ "Swap normals#C#menu"] [_ "Distance#C#menu"] [_ "Dimension#C#menu"] --- \
	    [_ "Repair model#C#menu"]]
    
    set MenuCommands(3) { { -np- UndoCom} "" \
	    {-np- ChangeVariables } { -np- ChangeLayers } "" "" "" {-np- CopyMove "Copy"} \
	    {-np- CopyMove "Move"} "" {utilities list status } {-np- AddListEntitiesToMenu %W  } \
	    {utilities renumber} {utilities Id} {-np- AddEntitiesToMenuAfter 0 %W \
	    {.central.s process escape escape escape escape utilities SignalEntities} } \
	    "" {-np- AddEntitiesToMenuSwapNormals %W } {utilities Dist} "" "" {utilities Repair}}
    
    set MenuAcceler(3) { Control-z "" Control-p Control-l "" "" ""  \
	    "Control-c" "Control-v" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIcons(3) {"" "" "prefs16x16.gif" "layers16x16.gif" "" "" "" "copy16x16.gif" "" \
	"" "" "list16x16.gif" "" "" "" "" "" "" ""}
    
    set MenuEntries(3,5) [list [_ "Toolbars#C#menu"]... --- \
	    [_ "Save window conf#C#menu"]... [_ "Move Screen Objects#C#menu"] --- \
	    [_ "Coordinates window#C#menu"]... [_ "Read batch window#C#menu"]... [_ "Comments#C#menu"]... \
	    [_ "Animation controls#C#menu"]... [_ "Animation script#C#menu"]... \
	    [_ "Macros#C#menu"]... [_ "Selection window#C#menu"]... --- [_ "Calculator#C#menu"]... [_ "Report#C#menu"]... \
	    [_ "Notes#C#menu"]...]
    set MenuIcons(3,5) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "Report16x16.gif" ""}
    
    set MenuCommands(3,5) { {-np- TOBegin} "" \
	    {-np- SaveWinConfiguration} { -ne- MoveScrObj} "" {-np- SetCoord} \
	    {-np- ReadBatch} {-np- CommentsW} \
	    {-np- PostAnimateControls} {-np- ::AutoAnimate::Crear} \
	    {-np- toolbarmacros::MacrosWindow} {-np- make_win_filter} \
	    "" {-np- CalculatorV} {-np- GIDReport::Crear} {-np- OpenNotes}}
    
    set MenuEntries(3,11) ""
    
    set MenuEntries(3,14) [list [_ "New point#C#menu"]]
    set MenuCommands(3,14) { {utilities SignalEntities Point FNoJoin} }
    set MenuIcons(3,14) { "" }

    set MenuEntries(3,16) ""

    set MenuEntries(3,18) [list [_ "Create#C#menu"] [_ "Delete#C#menu"] [_ "Edit#C#menu"] [_ "ShowBox#C#menu"] ]
    set MenuCommands(3,18) { "" {Utilities Dimension Delete} \
	{Utilities Dimension Edit} "" }
    
    set MenuEntries(3,18,0) [list [_ "Vertex#C#menu"] [_ "Distance#C#menu"] [_ "Angle#C#menu"] [_ "Radius#C#menu"] [_ "Text#C#menu"] ]
    set MenuCommands(3,18,0) { {Utilities Dimension Create Vertex} {Utilities Dimension Create Distance} \
	{Utilities Dimension Create Angle} {Utilities Dimension Create Radius} \
	    {Utilities Dimension Create Text} }
    
    set MenuEntries(3,18,3) [list [_ "On#C#menu"] [_ "Off#C#menu"] ]
    set MenuCommands(3,18,3) { {Utilities Dimension ShowBox} {Utilities Dimension HideBox} }

    
    #---------------

    set MenuEntries(4) ""
    set MenuCommands(4) {-np- PostDataMenu %W}
    set MenuAcceler(4) ""
    set MenuIcons(4) ""

    #---------------

    if { $::BOUNDARY_LAYER_MESH } {
    set MenuEntries(5) [list [_ "Unstructured#C#menu"] [_ "Structured#C#menu"] \
	    [_ "SemiStructured#C#menu"] [_ "Cartesian#C#menu"] --- [_ "Boundary layer#C#menu"] --- \
	    [_ "Quadratic elements#C#menu"] [_ "Element type#C#menu"]\
	    [_ "Mesh criteria#C#menu"] [_ "Reset mesh data#C#menu"] [_ "Draw#C#menu"] --- \
	    [_ "Generate mesh#C#menu"]... [_ "Erase mesh#C#menu"] [_ "Edit mesh#C#menu"] \
	    [_ "Show errors#C#menu"]... --- \
	    [_ "View mesh boundary#C#menu"] [_ "Create boundary mesh#C#menu"] --- [_ "Mesh quality#C#menu"]...]
	set MenuAcceler(5) { "" "" "" "" "" "" "" "" "" "" "" "" "" Control-g "" "" "" "" "" "" "" "" }
	set MenuIcons(5) { "" "" "" "" "" "" "" "" "" "" "" "" "" "mesh16x16.gif" "" "" "" "" "" "" "" ""}
	
	set MenuCommands(5) { "" "" "" "" "" "" "" "-np- QuadraticMenu %W" "" ""\
	    {Meshing reset} "" "" {Meshing Generate} {Meshing CancelMesh} "" {-np- MeshErrors} ""\
		{Meshing Boundaries} {Meshing CreateBoundary} "" {-np- MeshQuality} }
    } else {
	set MenuEntries(5) [list [_ "Unstructured#C#menu"] [_ "Structured#C#menu"] \
		[_ "SemiStructured#C#menu"] [_ "Cartesian#C#menu"] --- \
		[_ "Quadratic elements#C#menu"] [_ "Element type#C#menu"]\
		[_ "Mesh criteria#C#menu"] [_ "Reset mesh data#C#menu"] [_ "Draw#C#menu"] --- \
		[_ "Generate mesh#C#menu"]... [_ "Erase mesh#C#menu"] [_ "Edit mesh#C#menu"] \
		[_ "Show errors#C#menu"]... --- \
		[_ "View mesh boundary#C#menu"] [_ "Create boundary mesh#C#menu"] --- [_ "Mesh quality#C#menu"]...]
	set MenuAcceler(5) { "" "" "" "" "" "" "" "" "" "" "" Control-g "" "" "" "" "" "" "" "" }
	set MenuIcons(5) { "" "" "" "" "" "" "" "" "" "" "" "mesh16x16.gif" "" "" "" "" "" "" "" ""}
	
	set MenuCommands(5) { "" "" "" "" "" "-np- QuadraticMenu %W" "" ""\
	    {Meshing reset} "" "" {Meshing Generate} {Meshing CancelMesh} "" {-np- MeshErrors} ""\
	    {Meshing Boundaries} {Meshing CreateBoundary} "" {-np- MeshQuality} }
    }
    #set MenuEntries(5,0) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"] --- \
    #        [_ "By chordal error#C#menu"]... [_ "Correct sizes#C#menu"]... [_ "Background mesh#C#menu"]... \
    #        --- [_ "Assign entities#C#menu"]]
    set MenuEntries(5,0) [list [_ "Assign sizes on points#C#menu"] [_ "Assign sizes on lines#C#menu"] \
	    [_ "Assign sizes on surfaces#C#menu"] [_ "Assign sizes on volumes#C#menu"] --- \
	    [_ "Sizes by chordal error#C#menu"]... [_ "Sizes by background mesh#C#menu"]... \
	    [_ "Correct sizes#C#menu"]... --- [_ "Assign entities#C#menu"]]
    set MenuCommands(5,0) { {Meshing AssignSizes Points} \
	    {Meshing AssignSizes Lines} {Meshing AssignSizes Surfaces} \
	    {Meshing AssignSizes Volumes} "" {-np- CEBegin} \
	    {Meshing AssignSizes BackgMesh} {-np- CEBeginCorrectSizes} "" "" }
    set MenuIcons(5,0) { "point16x16.gif" "line16x16.gif" "surface16x16.gif" "volume16x16.gif" \
	"" "" "" "" "" "" }

    set MenuEntries(5,0,9) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,0,9) { {Meshing AssignSizes Lines 0.0} \
	{Meshing AssignSizes Surfaces 0.0} {Meshing AssignSizes Volumes 0.0} }
    
    set MenuEntries(5,1) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    if (0) { #proves amb la malla centrada estructurada
	set MenuCommands(5,1) { "" {Meshing Structured Surfaces} \
	    {Meshing Structured Volumes} }
    } else { 
	set MenuCommands(5,1) { "" "" {Meshing Structured Volumes} }
	set MenuIcons(5,1) { line16x16.gif surface16x16.gif volume16x16.gif }
	
	set MenuEntries(5,1,1) [list [_ "Assign#C#menu"] --- [_ "Center structured#C#menu"] [_ "Set center#C#menu"]]
	set MenuCommands(5,1,1) { {Meshing Structured Surfaces} "" {-np- CenterStructured Modeless} \
	    {Meshing CenterStruct SetCenter} }
    }
    
    set MenuEntries(5,1,0) [list [_ "Assign number of cells#C#menu"] [_ "Concentrate elements#C#menu"]]
    set MenuCommands(5,1,0) {{Meshing Structured Lines} \
    {Meshing StructConcentr} }

    set MenuEntries(5,2) [list [_ "Volumes#C#menu"] [_ "Set#C#menu"]]
    set MenuCommands(5,2) { {Meshing SemiStructured Volumes} "" }
    set MenuIcons(5,2) { volume16x16.gif "" }
    
    set MenuEntries(5,2,1) [list [_ "Master surface#C#menu"] [_ "Structured direction#C#menu"]]
    set MenuCommands(5,2,1) {{Meshing SemiStructured SetMaster} \
	    {Meshing SemiStructured SetDirection} }

    set MenuEntries(5,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] \
	    [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
    set MenuCommands(5,3) { {Meshing Cartesian Points} {Meshing Cartesian Lines} \
	    {Meshing Cartesian Surfaces} {Meshing Cartesian Volumes} }
    set MenuIcons(5,3) { point16x16.gif line16x16.gif surface16x16.gif volume16x16.gif }

    if { $::BOUNDARY_LAYER_MESH } {
	if { $::BOUNDARY_LAYER_MESH_3D } {
	    set MenuEntries(5,5) [list [_ "2 dimensional#C#menu"] [_ "3 dimensional#C#menu"]]
	    set MenuCommands(5,5)  { {Meshing BoundaryLayerMesh 2d} {Meshing BoundaryLayerMesh 3d} }
	} else {
	    set MenuEntries(5,5) [list [_ "2 dimensional#C#menu"]]
	    set MenuCommands(5,5)  { {Meshing BoundaryLayerMesh 2d} }
	}
    
	set MenuEntries(5,7) ""
	set MenuCommands(5,7) ""
	
	set MenuEntries(5,8) [list [_ "Default#C#menu"] [_ "Linear#C#menu"] --- \
		[_ "Triangle#C#menu"] [_ "Quadrilateral#C#menu"] --- \
		[_ "Tetrahedra#C#menu"] [_ "Hexahedra#C#menu"] \
		[_ "Prism#C#menu"] ---         [_ "Only points#C#menu"] \
		[_ "Sphere#C#menu"] [_ "Circle#C#menu"]]
	set MenuCommands(5,8) { "" "" "" \
		{-np- ChooseElemType Triangle} {-np- ChooseElemType Quadrilateral} "" \
		{-np- ChooseElemType Tetrahedra} {-np- ChooseElemType Hexahedra} \
		{-np- ChooseElemType Prism} "" {-np- ChooseElemType OnlyPoints} \
		{-np- ChooseElemType Sphere Volumes} {-np- ChooseElemType Circle Surfaces} }
	
	set MenuEntries(5,8,0) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,8,0) {{-np- ChooseElemType Default Surfaces} \
	    {-np- ChooseElemType Default Volumes}}
	
	#set MenuEntries(5,8,1) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	#set MenuCommands(5,8,1) {{-np- ChooseElemType Linear Lines} \
	    #        {-np- ChooseElemType Linear Surfaces} \
		#        {-np- ChooseElemType Linear Volumes}}
	set MenuEntries(5,8,1) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,8,1) {{-np- ChooseElemType Linear Surfaces} \
	    {-np- ChooseElemType Linear Volumes}}
	
	#set MenuEntries(5,8,11) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	#set MenuCommands(5,8,11) {{-np- ChooseElemType Sphere Surfaces} {-np- ChooseElemType Sphere Volumes}}
	
	set MenuEntries(5,9) [list [_ "Default#C#menu"] --- [_ "Mesh#C#menu,verb"] [_ "No mesh#C#menu,verb"] [_ "Default mesh#C#menu,verb" ] --- \
		[_ "Skip#C#menu"] [_ "No skip#C#menu"] [_ "Automatic skip#C#menu"] [_ "Skip by...#C#menu"] --- \
		[_ "Force points to#C#menu"] --- [_ "Duplicate#C#menu"] [_ "No Duplicate#C#menu"]]
	set MenuCommands(5,9) { "" "" "" "" "" "" "" "" "" {-np- RJBegin} "" "" "" "" ""}
	
	set MenuEntries(5,9,0) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,9,0) {{Meshing MeshCriteria DefaultAll Points} \
	    {Meshing MeshCriteria DefaultAll Lines} \
		{Meshing MeshCriteria DefaultAll Surfaces} \
		{Meshing MeshCriteria DefaultAll Volumes} }
	
	set MenuEntries(5,9,2) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,9,2) {{Meshing MeshCriteria Mesh Points} \
		{Meshing MeshCriteria Mesh Lines} \
		{Meshing MeshCriteria Mesh Surfaces} \
		{Meshing MeshCriteria Mesh Volumes} }
	
	set MenuEntries(5,9,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,9,3) {{Meshing MeshCriteria NoMesh Points} \
		{Meshing MeshCriteria NoMesh Lines} \
		{Meshing MeshCriteria NoMesh Surfaces} \
		{Meshing MeshCriteria NoMesh Volumes} }
	
	set MenuEntries(5,9,4) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,9,4) {{Meshing MeshCriteria DefaultMesh Points} \
		{Meshing MeshCriteria DefaultMesh Lines} \
		{Meshing MeshCriteria DefaultMesh Surfaces} \
		{Meshing MeshCriteria DefaultMesh Volumes} }
	
	set MenuEntries(5,9,6) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
	set MenuCommands(5,9,6) {{Meshing MeshCriteria Skip Points} \
	    {Meshing MeshCriteria Skip Lines} }
	
	set MenuEntries(5,9,7) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
	set MenuCommands(5,9,7) {{Meshing MeshCriteria NoSkip Points} \
	    {Meshing MeshCriteria NoSkip Lines} }
	
	set MenuEntries(5,9,8) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
	set MenuCommands(5,9,8) {{Meshing MeshCriteria DefaultSkip Points} \
	    {Meshing MeshCriteria DefaultSkip Lines} }
	
	set MenuEntries(5,9,11) [list [_ "Surface mesh#C#menu"] [_ "Volume mesh#C#menu"] ]
	set MenuCommands(5,9,11) {{Meshing MeshCriteria ForcePointsTo SurfaceMesh} \
	    {Meshing MeshCriteria ForcePointsTo VolumeMesh} }
	
	set MenuEntries(5,9,13) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]
	set MenuCommands(5,9,13) { {Meshing MeshCriteria DuplicateNodes Lines} \
	    {Meshing MeshCriteria DuplicateNodes Surfaces}}
	
	set MenuEntries(5,9,14) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]
	set MenuCommands(5,9,14) { {Meshing MeshCriteria NoDuplicateNodes Lines} \
	    {Meshing MeshCriteria NoDuplicateNodes Surfaces}}
	
	set MenuEntries(5,11) [list [_ "Sizes#C#menu"] [_ "Num of divisions#C#menu"] \
		[_ "Element type#C#menu"] [_ "Mesh / No mesh#C#menu,verb"] \
		[_ "Structured type#C#menu"] [_ "Skip entities (Rjump)#C#menu"] [_ "Duplicate#C#menu"] \
		[_ "Force points to#C#menu"] [_ "Boundary layer#C#menu"]]
	set MenuCommands(5,11) {"-np- DrawSizeMenu %W" {Meshing DrawNumOfDivisions Lines} \
	    "-np- DrawMenu %W ElementType" "-np- DrawMenuMeshNoMesh %W" "-np- DrawMenu %W StructuredType" \
	    {Meshing DrawRjumpSkip} {Meshing DrawDuplicate} "-np- DrawForcePointsToMesh %W" "-np- DrawBoundaryLayerMesh %W" }
	
	set MenuEntries(5,11,0) ""
	set MenuCommands(5,11,0) "" 
	
	set MenuEntries(5,11,2) ""
	set MenuCommands(5,11,2) ""
	
	set MenuEntries(5,11,3) ""
	set MenuCommands(5,11,3) ""
	
	set MenuEntries(5,11,4) ""
	set MenuCommands(5,11,4) ""

	set MenuEntries(5,11,7) ""
	set MenuCommands(5,11,7) ""
	
	set MenuEntries(5,11,8) ""
	set MenuCommands(5,11,8) ""
	
	set MenuEntries(5,15) [list [_ "Move node#C#menu"] ---   \
		[_ "Split elements#C#menu"] [_ "Smooth elements#C#menu"] --- \
		[_ "Collapse#C#menu"] [_ "Delete#C#menu"]]
	set MenuCommands(5,15) {{Meshing EditMesh MoveNode} "" \
	    "" {Meshing EditMesh Smoothing} ""  \
		""  "" }
	set MenuEntries(5,15,2) [list \
		[_ "Triangle#C#menu"]->[_ "Triangle#C#menu"] \
		[_ "Quadrilateral#C#menu"]->[_ "Triangle#C#menu"] \
		--- \
		[_ "Tetrahedra#C#menu"]->[_ "Tetrahedra#C#menu"] \
		[_ "Hexahedra#C#menu"]->[_ "Tetrahedra#C#menu"] \
		[_ "Prism#C#menu"]->[_ "Tetrahedra#C#menu"] ]
	set MenuCommands(5,15,2) [list \
		{Meshing EditMesh SplitElems TriaToTria} \
		{Meshing EditMesh SplitElems QuadToTriangle} \
		{} \
		{Meshing EditMesh SplitElems TetraToTetra} \
		{Meshing EditMesh SplitElems HexaToTetra} \
		{Meshing EditMesh SplitElems PrismToTetra} \
		]
	set MenuEntries(5,15,5) [ list [_ "Mesh#C#menu"] --- [_ "Edges#C#menu"] [_ "Nodes#C#menu"] [_ "Elements#C#menu"] ]
	set MenuCommands(5,15,5) { {utilities Collapse mesh} "" {utilities Collapse edges} \
	    {utilities Collapse nodes} {utilities Collapse elements} }
    
	set MenuEntries(5,15,6) [ list [_ "Nodes#C#menu"] [_ "Elements#C#menu"] ]
	set MenuCommands(5,15,6) { {Meshing EditMesh DeleteNodes} {Meshing EditMesh DeleteElems} }
    } else {
	set MenuEntries(5,5) ""
	set MenuCommands(5,5) ""
	
	set MenuEntries(5,6) [list [_ "Default#C#menu"] [_ "Linear#C#menu"] --- \
		[_ "Triangle#C#menu"] [_ "Quadrilateral#C#menu"] --- \
		[_ "Tetrahedra#C#menu"] [_ "Hexahedra#C#menu"] \
		[_ "Prism#C#menu"] --- [_ "Only points#C#menu"] \
		[_ "Sphere#C#menu"] [_ "Circle#C#menu"]]
	set MenuCommands(5,6) { "" "" "" \
	    {-np- ChooseElemType Triangle} {-np- ChooseElemType Quadrilateral} "" \
	{-np- ChooseElemType Tetrahedra} {-np- ChooseElemType Hexahedra} \
	    {-np- ChooseElemType Prism} "" {-np- ChooseElemType OnlyPoints} \
	    {-np- ChooseElemType Sphere Volumes} {-np- ChooseElemType Circle Surfaces} }
	
	set MenuEntries(5,6,0) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,6,0) {{-np- ChooseElemType Default Surfaces} \
	    {-np- ChooseElemType Default Volumes}}
	
	#set MenuEntries(5,6,1) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	#set MenuCommands(5,6,1) {{-np- ChooseElemType Linear Lines} \
	    #        {-np- ChooseElemType Linear Surfaces} \
		#        {-np- ChooseElemType Linear Volumes}}
	set MenuEntries(5,6,1) [list [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,6,1) {{-np- ChooseElemType Linear Surfaces} \
	    {-np- ChooseElemType Linear Volumes}}        
	
	set MenuEntries(5,7) [list [_ "Default#C#menu"] --- [_ "Mesh#C#menu,verb"] [_ "No mesh#C#menu,verb"] [_ "Default mesh#C#menu,verb" ] --- \
		[_ "Skip#C#menu"] [_ "No skip#C#menu"] [_ "Automatic skip#C#menu"] [_ "Skip by...#C#menu"] --- \
		[_ "Force points to#C#menu"] --- [_ "Duplicate#C#menu"] [_ "No Duplicate#C#menu"]]
	set MenuCommands(5,7) { "" "" "" "" "" "" "" "" "" {-np- RJBegin} "" "" "" "" ""}
	
	set MenuEntries(5,7,0) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,7,0) {{Meshing MeshCriteria DefaultAll Points} \
	    {Meshing MeshCriteria DefaultAll Lines} \
		{Meshing MeshCriteria DefaultAll Surfaces} \
		{Meshing MeshCriteria DefaultAll Volumes} }
	
	set MenuEntries(5,7,2) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,7,2) {{Meshing MeshCriteria Mesh Points} \
		{Meshing MeshCriteria Mesh Lines} \
		{Meshing MeshCriteria Mesh Surfaces} \
		{Meshing MeshCriteria Mesh Volumes} }
	
	set MenuEntries(5,7,3) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,7,3) {{Meshing MeshCriteria NoMesh Points} \
		{Meshing MeshCriteria NoMesh Lines} \
		{Meshing MeshCriteria NoMesh Surfaces} \
		{Meshing MeshCriteria NoMesh Volumes} }
	
	set MenuEntries(5,7,4) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] [_ "Surfaces#C#menu"] [_ "Volumes#C#menu"]]
	set MenuCommands(5,7,4) {{Meshing MeshCriteria DefaultMesh Points} \
		{Meshing MeshCriteria DefaultMesh Lines} \
		{Meshing MeshCriteria DefaultMesh Surfaces} \
		{Meshing MeshCriteria DefaultMesh Volumes} }
	
	set MenuEntries(5,7,6) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
	set MenuCommands(5,7,6) {{Meshing MeshCriteria Skip Points} \
	    {Meshing MeshCriteria Skip Lines} }
	
	set MenuEntries(5,7,7) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
	set MenuCommands(5,7,7) {{Meshing MeshCriteria NoSkip Points} \
	    {Meshing MeshCriteria NoSkip Lines} }
	
	set MenuEntries(5,7,8) [list [_ "Points#C#menu"] [_ "Lines#C#menu"] ]
	set MenuCommands(5,7,8) {{Meshing MeshCriteria DefaultSkip Points} \
	    {Meshing MeshCriteria DefaultSkip Lines} }
	
	set MenuEntries(5,7,11) [list [_ "Surface mesh#C#menu"] [_ "Volume mesh#C#menu"] ]
	set MenuCommands(5,7,11) {{Meshing MeshCriteria ForcePointsTo SurfaceMesh} \
	    {Meshing MeshCriteria ForcePointsTo VolumeMesh} }
	
	set MenuEntries(5,7,13) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]
	set MenuCommands(5,7,13) { {Meshing MeshCriteria DuplicateNodes Lines} \
	    {Meshing MeshCriteria DuplicateNodes Surfaces}}
	
	set MenuEntries(5,7,14) [list [_ "Lines#C#menu"] [_ "Surfaces#C#menu"]]
	set MenuCommands(5,7,14) { {Meshing MeshCriteria NoDuplicateNodes Lines} \
	    {Meshing MeshCriteria NoDuplicateNodes Surfaces}}
	
	set MenuEntries(5,9) [list [_ "Sizes#C#menu"] [_ "Num of divisions#C#menu"] \
		[_ "Element type#C#menu"] [_ "Mesh / No mesh#C#menu,verb"] \
		[_ "Structured type#C#menu"] [_ "Skip entities (Rjump)#C#menu"] [_ "Duplicate#C#menu"] \
		[_ "Force points to#C#menu"]]
	set MenuCommands(5,9) {"-np- DrawSizeMenu %W" {Meshing DrawNumOfDivisions Lines} \
	    "-np- DrawMenu %W ElementType" "-np- DrawMenuMeshNoMesh %W" "-np- DrawMenu %W StructuredType" \
	    {Meshing DrawRjumpSkip} {Meshing DrawDuplicate} "-np- DrawForcePointsToMesh %W"}
	
	set MenuEntries(5,9,0) ""
	set MenuCommands(5,9,0) "" 
	
	set MenuEntries(5,9,2) ""
	set MenuCommands(5,9,2) ""
	
	set MenuEntries(5,9,3) ""
	set MenuCommands(5,9,3) ""
	
	set MenuEntries(5,9,4) ""
	set MenuCommands(5,9,4) ""
	
	set MenuEntries(5,9,7) ""
	set MenuCommands(5,9,7) ""
	
	set MenuEntries(5,13) [list [_ "Move node#C#menu"] ---   \
		[_ "Split elements#C#menu"] [_ "Smooth elements#C#menu"] --- \
		[_ "Collapse#C#menu"] [_ "Delete#C#menu"]]
	set MenuCommands(5,13) {{Meshing EditMesh MoveNode} "" \
	    "" {Meshing EditMesh Smoothing} ""  \
		""  "" }
	set MenuEntries(5,13,2) [list \
		[_ "Triangle#C#menu"]->[_ "Triangle#C#menu"] \
		[_ "Quadrilateral#C#menu"]->[_ "Triangle#C#menu"] \
		--- \
		[_ "Tetrahedra#C#menu"]->[_ "Tetrahedra#C#menu"] \
		[_ "Hexahedra#C#menu"]->[_ "Tetrahedra#C#menu"] \
		[_ "Prism#C#menu"]->[_ "Tetrahedra#C#menu"] ]
	set MenuCommands(5,13,2) [list \
		{Meshing EditMesh SplitElems TriaToTria} \
		{Meshing EditMesh SplitElems QuadToTriangle} \
		{} \
		{Meshing EditMesh SplitElems TetraToTetra} \
		{Meshing EditMesh SplitElems HexaToTetra} \
		{Meshing EditMesh SplitElems PrismToTetra} \
		]
	set MenuEntries(5,13,5) [ list [_ "Mesh#C#menu"] --- [_ "Edges#C#menu"] [_ "Nodes#C#menu"] [_ "Elements#C#menu"] ]
	set MenuCommands(5,13,5) { {utilities Collapse mesh} "" {utilities Collapse edges} \
	    {utilities Collapse nodes} {utilities Collapse elements} }
    
	set MenuEntries(5,13,6) [ list [_ "Nodes#C#menu"] [_ "Elements#C#menu"] ]
	set MenuCommands(5,13,6) { {Meshing EditMesh DeleteNodes} {Meshing EditMesh DeleteElems} }
    }

    #---------------
    
    set MenuEntries(6) [list  [_ "Calculate#C#menu"] [_ "Calculate remote#C#menu"] ---\
	    [_ "Cancel process#C#menu"] [_ "View process info#C#menu"]... [_ "Calculate window#C#menu"]... ]
    set MenuCommands(6) {  {Utilities Calculate} {Utilities RemoteCalc} "" {Utilities CancelProcess} \
	"-np- PWViewOutput" "-np- RunWin " }
    
    set MenuAcceler(6) { "" "" "" "" "" ""}
    set MenuIcons(6) {"calc16x16.gif" "" "" "" "info16x16.gif" "" }
    
    #---------------- 
    
    
    set MenuEntries(7) [list [_ "Help#C#menu"]... [_ "Customization Help#C#menu"]... [_ "Tutorials#C#menu"]... \
	    [_ "What is new#C#menu"]... [_ "FAQ#C#menu"]... --- [_ "Register GiD#C#menu"]... [_ "Register Problem type#C#menu"]... \
	    [_ "Register from file#C#menu"]...  --- [_ "Visit %s web" $::GidPriv(ProgName)]... [_ "About#C#menu"]... ]
    set MenuCommands(7) [list {-np- GiDHelpWindow -type REFERENCE -start html-version} \
	    {-np- GiDHelpWindow  -type REFERENCE -start html-customization} \
	    { -np- CreateTutorial_win} { -np- GiDHelpWindow -type REFERENCE -start html_whatsnew} \
	    {-np- GiDHelpWindow -type REFERENCE -start html-faq} "" {-np- gidregister} \
	    {-np- gidregister module} {-np- RegisterFromFileW} "" "-np- VisitWeb $GidPriv(ProgWeb)" \
	    {-np- CreateWelcomeWin}]
    set MenuAcceler(7) { F1 "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIcons(7) {"help16x16.gif" "" "" "" "" "" "" "" "" "" "" ""}
    
}
#-----------------------------------------------------------

proc SetBitmapNames {} {
    global BitMapsNames BitMapsCommands BitmapsHelp GidPriv
    
    catch { unset BitMapsNames BitMapsCommands BitmapsHelp }
    
    if { !$GidPriv(separadores)} {
	set BitMapsNames(0) { zoomin.gif zoomout.gif zframe.gif redraw.gif \
				  rotate.gif pan.gif line.gif arc.gif spline.gif \
				  poly.gif coonsurf.gif volume.gif object.gif erase.gif list.gif \
				  view_geom_mesh.gif }
	
	set BitMapsCommands(0) { {-ne- zoom in} {-ne- zoom out} {-ne- zoom frame} \
				     {-ne- redraw} {-ne- rotate trackball} {-ne- dynamicpan }  \
				     {geometry create line} \
				     {geometry create arc} {geometry create NurbsLine} \
				     {geometry create Polyline} \
				     {geometry create NurbsSurface} {geometry create volume} "" \
				     {-np- AddBitmapsDeleteMenu %W } \
				     {-np- AddBitmapsToMenu %W {.central.s process \
								    escape escape escape escape utilities list } } \
				     {-np- ToggleGeomMesh} }
	
	set BitMapsNames(0,13) { rectangle.gif polygonPNR.gif CirclePNR.gif \
				     sphere.gif cylinder.gif cone.gif Prism.gif tori.gif }
	
	set BitMapsCommands(0,13) { {geometry create Object Rectangle } \
					{geometry create Object PolygonPNR } \
					{geometry create Object CirclePNR } {geometry create Object Sphere } \
					{geometry create Object Cylinder } {geometry create Object Cone } \
					{geometry create Object Prism } {geometry create Object Torus} }
	
	#set BitMapsNames(0,14) { point.gif line.gif coonsurf.gif volume.gif alltypes.gif }
	
	#set BitMapsCommands(0,14) { {geometry delete point} {geometry delete line} \
	    #{geometry delete surface}  {geometry delete volume} {geometry delete all} }
	set BitMapsNames(0,14) {}
	set BitMapsCommands(0,14) {}
	
	set BitMapsNames(0,15) {}
	set BitMapsCommands(0,15) {}
	
	set BitmapsHelp(0) [list [_ "Zoom in"] [_ "Zoom out"] [_ "Zoom frame"] [_ "Redraw"] \
				[_ "Rotate trackball"] [_ "Pan dynamic"] [_ "Create line"] [_ "Create arc"] \
				[_ "Create nurbs line"] [_ "Create polyline"] \
				[_ "Create NURBS surface"] [_ "Create volume"] \
				[_ "Create Object:\n  Rectangle\n Polygon\n  Circle\n  Sphere\n  Cylinder\n  Cone\n  Prism\n Thorus"] \
				[_ "Delete"] \
				[_ "List entities"] [_ "Toggle geometry-mesh view"] ]
	
    } else {
	set BitMapsNames(0) { zoomin.gif zoomout.gif zframe.gif redraw.gif \
				  rotate.gif pan.gif --- line.gif arc.gif spline.gif \
				  poly.gif --- coonsurf.gif volume.gif object.gif --- erase.gif \
				  list.gif --- view_geom_mesh.gif }
	
	#test of more small icons
	set GidPriv(smallicons) 0
	if { [info exists GidPriv(smallicons)] && $GidPriv(smallicons) == "1" } {
	    set tmp ""
	    foreach i $BitMapsNames(0) {
		if { $i == "---" } {
		    lappend tmp $i
		} else {
		    lappend tmp [file root $i]_24x20.gif
		}
	    }
	    set BitMapsNames(0) $tmp
	}
	
	set BitMapsCommands(0) { {-ne- zoom in} {-ne- zoom out} {-ne- zoom frame} \
				     {-ne- redraw} {-ne- rotate trackball} {-ne- dynamicpan } "" \
				     {geometry create line} \
				     {geometry create arc} {geometry create NurbsLine} \
				     {geometry create Polyline} "" \
				     {geometry create NurbsSurface} {geometry create volume} "" "" \
				     {-np- AddBitmapsDeleteMenu %W } \
				     {-np- AddBitmapsToMenu %W {.central.s process escape escape escape escape utilities list } } \
				     "" {-np- ToggleGeomMesh} }
	
	set BitMapsNames(0,14) { rectangle.gif polygonPNR.gif CirclePNR.gif \
				     sphere.gif cylinder.gif cone.gif Prism.gif tori.gif }
	
	set BitMapsCommands(0,14) { {geometry create Object Rectangle } \
					{geometry create Object PolygonPNR } \
					{geometry create Object CirclePNR } {geometry create Object Sphere } \
					{geometry create Object Cylinder } {geometry create Object Cone } \
					{geometry create Object Prism } {geometry create Object Torus }}
	
	set BitMapsNames(0,16) {}
	set BitMapsCommands(0,16) {}
	
	set BitMapsNames(0,17) {}
	set BitMapsCommands(0,17) {}
	
	set BitmapsHelp(0) [list [_ "Zoom in"] [_ "Zoom out"] [_ "Zoom frame"] [_ "Redraw"] \
				[_ "Rotate trackball"] [_ "Pan dynamic"] "" [_ "Create line"] [_ "Create arc"] \
				[_ "Create nurbs line"] [_ "Create polyline"] "" \
				[_ "Create NURBS surface"] [_ "Create volume"] \
				[_ "Create Object:\n  Rectangle\n Polygon\n  Circle\n  Sphere\n  Cylinder\n  Cone\n  Prism\n Thorus"]\
				"" [_ "Delete"] [_ "List entities"] "" [_ "Toggle geometry-mesh view"]]
	
	set BitmapsHelp(0) [list [_ "Zoom in"] [_ "Zoom out"] [_ "Zoom frame"] [_ "Redraw"] \
				[_ "Rotate trackball"] [_ "Pan dynamic"] "" [_ "Create line"] [_ "Create arc"] \
				[_ "Create nurbs line"] [_ "Create polyline"] "" \
				[_ "Create NURBS surface"] [_ "Create volume"] \
				[_ "Create Object:\n  Rectangle\n Polygon\n  Circle\n  Sphere\n  Cylinder\n  Cone\n  Prism\n Thorus"]\
				"" [_ "Delete"] \
				[_ "List entities"] "" [_ "Toggle geometry-mesh view"]]
    }
    
}


#-----------------------------------------------------------

proc Set3dButtonVariables {} {
    global 3dButtonNames 3dButtonDisabled 3dButtonDisabledP 3dButtonCommands 3dButtonChange 3dButtonChangeP
    global tcl_platform
    global 3dButtonIcons
    
    catch { unset 3dButtonNames 3dButtonDisabled 3dButtonDisabledP 3dButtonCommands 3dButtonIcons}
    
    if { $tcl_platform(platform) != "windows" } {
	set 3dButtonNames(0) [list [_ "Contextual#C#menu"] --- [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] \
		[_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Label#C#menu"] [_ "Layer#C#menu"] --- [_ "Quit#C#menu"]]
    } else {
	set 3dButtonNames(0) [list [_ "Contextual#C#menu"] --- [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] \
		[_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Label#C#menu"] [_ "Layer#C#menu"] --- [_ "Image to clipboard#C#menu"] \
		--- [_ "Quit#C#menu"]]
    }

    
    set 3dButtonDisabled ""
    set 3dButtonDisabledP [list [_ "Layer#C#menu"]]

    
    if { $tcl_platform(platform) != "windows" } {
	set 3dButtonCommands(0) { {-np- ContextualSubMenu %W} "" "" "" "" {-ne- redraw } \
		{-np- AddChangeToRender %W} "" "" "" Quit }
	set 3dButtonIcons(0) { "" "" "" "" "" "redraw16x16.gif" "" "" \
		"" "" "exit16x16.gif" }
    } else {
	set 3dButtonCommands(0) { {-np- ContextualSubMenu %W} "" "" "" "" {-ne- redraw } \
		{-np- AddChangeToRender %W} "" "" "" {-ne- hardcopy copyclipboard} "" Quit }
	set 3dButtonIcons(0) { "" "" "" "" "" "redraw16x16.gif" "" "" \
		"" "" "" "" "exit16x16.gif" }
    }

    set 3dButtonNames(0,0) {}
    set 3dButtonCommands(0,0) {}
    
    set 3dButtonNames(0,2) [list [_ "In#C#menu"] [_ "Out#C#menu"] --- [_ "Dynamic#C#menu"] [_ "Previous#C#menu"] [_ "Next#C#menu"] \
	    --- [_ "Frame#C#menu"]]
    set 3dButtonCommands(0,2) { {-ne- zoom in} {-ne- zoom out} "" {-ne- zoom dynamic} \
	    {-ne- zoom previous} {-ne- zoom next} "" {-ne- zoom frame} }
    set 3dButtonIcons(0,2) { "zoomin16x16.gif" "zoomout16x16.gif" "" "" "" "" "" "zframe16x16.gif" }
    
    set 3dButtonNames(0,3) [list [_ "Trackball#C#menu"] [_ "Screen axes#C#menu"] [_ "Object axes#C#menu"] \
	    [_ "Center#C#menu"] --- [_ "Plane XY (Original)#C#menu"] [_ "Plane XZ#C#menu"] [_ "Plane YZ#C#menu"] [_ "Isometric#C#menu"]]
    set 3dButtonCommands(0,3) { {-ne- rotate Trackball} {-ne- rotate ScrAxes} \
	    {-ne- rotate ObjAxes}  {-ne- rotate Center FJoin} \
	    "" {-ne- rotate angle 270 90} {-ne- rotate angle 270 0} \
	    {-ne- rotate angle 0 0} {-ne- rotate angle 45 45} }
    set 3dButtonIcons(0,3) { "rotate16x16.gif" "" "" "" "" "" "" "" "" }

    set 3dButtonNames(0,4) [list [_ "Two point#C#menu"] [_ "Dynamic#C#menu"]]
    set 3dButtonCommands(0,4) { {-ne- pan} {-ne- DynamicPan} }
    set 3dButtonIcons(0,4) { "" "pan16x16.gif" }
    
    set 3dButtonNames(0,6) {}
    set 3dButtonCommands(0,6) {}

    set 3dButtonNames(0,7) [list [_ "All#C#menu"] [_ "All in#C#menu"] [_ "Select#C#menu"] --- [_ "Off#C#menu"]]
    set 3dButtonCommands(0,7) { {-ne- label All} \
	    {-np- AddBitmapsToMenu %W {.central.s process label  } } \
	    {-np- AddBitmapsToMenu %W {.central.s process label Select } } "" \
	    {-ne- label Off} }
    set 3dButtonNames(0,7,1) {}
    set 3dButtonCommands(0,7,1) {}
    set 3dButtonNames(0,7,2) {}
    set 3dButtonCommands(0,7,2) {}

    set 3dButtonNames(0,8) [list [_ "New#C#menu"] [_ "On#C#menu"] [_ "Off#C#menu"] [_ "To use#C#menu"] [_ "Send#C#menu"] [_ "Window#C#menu"]]
    set 3dButtonCommands(0,8) { { -np- CreateNewLayer } \
	    {-np- AddLayerOnOff ON %W {GiD_Process layers on }} \
	    {-np- AddLayerOnOff OFF %W {GiD_Process layers off }} \
	    {-np- AddLayerOnOff TOUSE %W {GiD_Process layers ToUse }} \
	    {-np- LayerEntities %W} { -np- ChangeLayers } }
    set 3dButtonIcons(0,8) { "" "" "" "" "" "layers16x16.gif" }
    
   
    set 3dButtonNames(0,8,1) {}
    set 3dButtonNames(0,8,2) {}
    set 3dButtonNames(0,8,3) {}
    set 3dButtonNames(0,8,4) {}

    set 3dButtonCommands(0,8,1) {}
    set 3dButtonCommands(0,8,2) {}
    set 3dButtonCommands(0,8,3) {}
    set 3dButtonCommands(0,8,4) {}
}

#------------------------------------------------------------------------

proc SetMenusVariablesP {} {
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP MenuIconsP
    global tcl_platform GidPriv GIDDEFAULT

    catch { unset MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP MenuIconsP }

    set MenuNamesP [list [_ "Files#C#menu"] [_ "View#C#menu,Verb"] [_ "Utilities#C#menu"] [_ "Do cuts#C#menu"] [_ "View results#C#menu"] [_ "Options#C#menu"] \
	    [_ "Window#C#menu"] [_ "Help#C#menu"]]

    #-----------------
    
    set MenuEntriesP(0) [list [_ "New#C#menu"] [_ "Open#C#menu"]... [_ "Open multiple#C#menu"]... [_ "Merge#C#menu"]... [_ "Import#C#menu"] [_ "Export#C#menu"] \
		             --- [_ "Preprocess#C#menu"] --- [_ "Print to file#C#menu"] [_ "Page Setup#C#menu"]... [_ "Print#C#menu"] --- \
		             [_ "Recent post files#C#menu"] [_ "Recent projects#C#menu"] --- [_ "Quit#C#menu"] ]
    set MenuCommandsP(0) { { files new} { files read} { files ReadMultiple} { files add} "" "" \
	"" {preprocess} "" "" {-np- PageSetup} {-np- HardcopyToPrint {Hardcopy PS}} "" \
		               {-np- AddEntitiesToMenuRecentPostFiles %W } {-np- AddEntitiesToMenuRecentProjects %W } "" {quit} }

    set MenuAccelerP(0) { "Control-n" Control-o "" "" "" "" "" "" "" "" "" "" "" "" "" "" Control-q }
    set MenuIconsP(0) { "new16x16.gif" "open16x16.gif" "" "" "" "" "" "prepost16x16.gif" "" \
	"camera16x16.gif" "" "print16x16.gif" "" "" "" "" "exit16x16.gif" }

    set MenuEntriesP(0,4) [list [_ "NASTRAN mesh#C#menu"]... [_ "FEMAP file#C#menu"]... [_ "TECPLOT ASCII file#C#menu"]...  \
		               [_ "3D Studio file#C#menu"]... --- [_ "Cut#C#menu"]...  [_ "Graph#C#menu"]...]

    set MenuCommandsP(0,4) { { files readNASTRAN} { files readFEMAP} { files readTECPLOT} \
		                 { files read3DStudio} "" { files readcut} { results graphs readgraph} }

    
    set MenuEntriesP(0,5) [list [_ "Post information#C#menu"] [_ "Cut#C#menu"] [_ "Graph#C#menu"] [_ "Cover mesh#C#menu"]...]

    set MenuCommandsP(0,5) { "" \
	    {-np- AddCutsToMenu %W { .central.s process escape escape escape escape files savecut}} \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape \
	    results graphs writegraph} 1} \
	    { Files savecovermesh} }
    
    set MenuEntriesP(0,5,0) [list [_ "ASCII files#C#menu"]... [_ "Binary (whole model)#C#menu"]... [_ "Binary (only results)#C#menu"] \
	    [_ "ASCII boundaries#C#menu"]...]

    set MenuCommandsP(0,5,0) { { files saveall allmeshessets} \
	    { files saveall binMeshesSets} { files saveall binRes} \
	    { files saveall boundaries} }
    
    set MenuEntriesP(0,5,1) ""

    set MenuEntriesP(0,5,2) ""

    set MenuEntriesP(0,9) [list [_ "PS/EPS Screen#C#menu"]... [_ "PS/EPS Vectorial#C#menu"]... --- \
	    [_ "BMP#C#menu"]... [_ "GIF#C#menu"]... [_ "JPEG#C#menu"]... [_ "PNG#C#menu"]... [_ "TGA#C#menu"]... [_ "TIFF#C#menu"]... [_ "VRML#C#menu"]...]
    
    set MenuCommandsP(0,9) { "" "" "" \
	    { -ne- Hardcopy BMP} \
	    { -ne- Hardcopy GIF} \
	    { -ne- Hardcopy JPEG} \
	    { -ne- Hardcopy PNG} \
	    { -ne- Hardcopy TGA} \
	    { -ne- Hardcopy TIFF} \
	    { -ne- Hardcopy VRML} }
    
    set MenuEntriesP(0,9,0) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommandsP(0,9,0) { { -ne- Hardcopy Options VectorialPS no escape Hardcopy PS} \
	    { -ne- Hardcopy Options VectorialPS no escape Hardcopy EPS} }
    
    set MenuEntriesP(0,9,1) [list [_ "PS#C#menu"]... [_ "EPS#C#menu"]...]
    set MenuCommandsP(0,9,1) { { -ne- Hardcopy Options VectorialPS yes escape Hardcopy PS } \
	    { -ne- Hardcopy Options VectorialPS yes escape Hardcopy EPS} }

    set MenuEntriesP(0,13) ""
    set MenuEntriesP(0,14) ""
    
    #-----------------

    #copyclipboard only available for windows
    set what "POST"
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntriesP(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		                 [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... [_ "Clip planes#C#menu"]... \
		                 --- [_ "Label#C#menu"] [_ "View#C#menu,Noun"] \
		                 [_ "Recent view files#C#menu"] --- [_ "Background image#C#menu"] \
		                 [_ "Image to clipboard#C#menu"] [_ "Multiple windows#C#menu"]... --- [_ "Mode#C#menu"] ]
	set MenuCommandsP(1) [list "" "" "" "" \
		                  {-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} {-np- ClipPlanes} "" \
		                  "" "" {-np- AddEntitiesToMenuRecentViewFiles %W } "" \
		                  "" {-ne- hardcopy copyclipboard} \
		                  "-np- ViewSeveralWindows"  "" "-np- ViewModeMenu %W $what" ]
	set MenuAccelerP(1) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" }
	set MenuIconsP(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" \
		                "" "" "" "" "" }
    } else {
	set MenuEntriesP(1) [list [_ "Zoom#C#menu"] [_ "Rotate#C#menu"] [_ "Pan#C#menu"] --- \
		                 [_ "Redraw#C#menu"] [_ "Render#C#menu"] [_ "Perspective#C#menu"]... [_ "Clip planes#C#menu"]... \
		                 --- [_ "Label#C#menu"] [_ "View#C#menu,Noun"] \
		                 [_ "Recent view files#C#menu"] --- [_ "Background image#C#menu"] \
		                 [_ "Multiple windows#C#menu"]... --- [_ "Mode#C#menu"] ]
	set MenuCommandsP(1) [list "" "" "" "" \
		                  {-ne- redraw } {-np- AddChangeToRender %W} {-np- PerspectiveW} {-np- ClipPlanes} "" \
		                  "" "" {-np- AddEntitiesToMenuRecentViewFiles %W } "" \
		                  "" "-np- ViewSeveralWindows" "" "-np- ViewModeMenu %W $what" ]
	set MenuAccelerP(1) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" }
	set MenuIconsP(1) { "" "" "" "" "redraw16x16.gif" "" "" "" "" "" "" "" "" "" "" "" }
    }

    set MenuEntriesP(1,0) [list [_ "In#C#menu"] [_ "Out#C#menu"] --- [_ "Dynamic#C#menu"] [_ "Previous#C#menu"] \
	    [_ "Next#C#menu"] --- [_ "Frame#C#menu"]]
    set MenuCommandsP(1,0) { {-ne- zoom in} {-ne- zoom out} "" \
	    {-ne- zoom dynamic} \
	    {-ne- zoom previous} {-ne- zoom next} "" {-ne- zoom frame} }
    set MenuIconsP(1,0) { "zoomin16x16.gif" "zoomout16x16.gif" "" "" "" "" "" "zframe16x16.gif" }
    
    set MenuEntriesP(1,1) [list [_ "Trackball#C#menu"] [_ "Screen axes#C#menu"] [_ "Object axes#C#menu"] \
	    [_ "Center#C#menu"] --- [_ "Plane XY (Original)#C#menu"] [_ "Plane XZ#C#menu"] [_ "Plane YZ#C#menu"] [_ "Isometric#C#menu"]]
    set MenuCommandsP(1,1) { {-ne- rotate Trackball} {-ne- rotate ScrAxes} \
	    {-ne- rotate ObjAxes}  {-ne- rotate Center FJoin} \
	    "" {-ne- rotate angle 270 90} {-ne- rotate angle 270 0} \
	    {-ne- rotate angle 0 0} {-ne- rotate angle 45 45} }
    set MenuIconsP(1,1) { "rotate16x16.gif" "" "" "" "" "" "" "" "" }
    
    set MenuEntriesP(1,2) [list [_ "Two point#C#menu"] [_ "Dynamic#C#menu"]]
    set MenuCommandsP(1,2) { {-ne- pan} {-ne- DynamicPan} }
    set MenuIconsP(1,2) { "" "pan16x16.gif" }
    
    set MenuEntriesP(1,5) ""
    set MenuCommandsP(1,5) ""
    
    set MenuEntriesP(1,9) [list [_ "All#C#menu"] [_ "All in#C#menu"] [_ "Select#C#menu"] --- [_ "Off#C#menu"]]
    set MenuCommandsP(1,9) { {-ne- label All} \
	    {-np- AddBitmapsToMenu %W {.central.s process label  } } \
	    {-np- AddBitmapsToMenu %W {.central.s process label Select } } "" \
	    {-ne- label Off} }
    set MenuEntriesP(1,9,1) {}
    set MenuCommandsP(1,9,1) {}

    set MenuEntriesP(1,9,2) {}
    set MenuCommandsP(1,9,2) {}
    
    set MenuEntriesP(1,10) [list [_ "Save#C#menu"]... [_ "Read#C#menu"]...]
    set MenuCommandsP(1,10) { {View SaveView} {View ReadView} }

    set MenuEntriesP(1,11) {}
    set MenuCommandsP(1,11) {}
    
    set MenuEntriesP(1,13) [list [_ "Fit screen#C#menu"]... [_ "Real size#C#menu"]... [_ "Default#C#menu"] ]
    set MenuCommandsP(1,13) { { utilities backgroundimg backgroundimg} \
	    { utilities backgroundimg realsizeimg} { utilities backgroundimg default} }
    # view mode
    if { $tcl_platform(platform) == "windows" } {
	set MenuEntriesP(1,17) ""
	set MenuCommandsP(1,17) ""
    } else {
	set MenuEntriesP(1,16) ""
	set MenuCommandsP(1,16) ""
    }

    #-----------------

    if { $GidPriv(Texturas)} {
	set MenuEntriesP(2) [list  [_ "Preferences#C#menu"]... [_ "View style#C#menu"]... --- \
		[_ "Tools#C#menu"] --- [_ "Copy#C#menu"] [_ "Status#C#menu"]... [_ "List#C#menu"] \
		[_ "Id#C#menu"] [_ "Signal#C#menu"] [_ "Distance#C#menu"] [_ "Dimension#C#menu"] --- \
		[_ "Collapse nodes#C#menu"] [_ "Join#C#menu"] [_ "Delete#C#menu"] [_ "Texture#C#menu"] ]
	set MenuCommandsP(2) { {-np- ChangeVariables} { -np- PostDisplay } "" "" "" \
		{-np- CopyMove "Copy" } {utilities list status } "" {utilities id}  {-np- AddEntitiesToMenu %W \
		{.central.s process escape escape escape escape utilities \
		SignalEntities } } {utilities dist} "" "" {utilities collapse} "" "" "" }
	set MenuAccelerP(2) { Control-p Control-l "" "" "" Control-c "" "" "" "" "" "" "" "" "" "" "" "" "" }
	set MenuIconsP(2) { "prefs16x16.gif" "layers16x16.gif" "" "" "" "copy16x16.gif" "" \
	    "list16x16.gif" "" "" "" "" "" "" "" "" "" "" "" }
    } else {
	set MenuEntriesP(2) [list  [_ "Preferences#C#menu"]... [_ "View style#C#menu"]... --- \
		[_ "Tools#C#menu"] --- [_ "Copy#C#menu"] [_ "Status#C#menu"]... [_ "List#C#menu"] \
		[_ "Id#C#menu"] [_ "Signal#C#menu"] [_ "Distance#C#menu"] [_ "Dimension#C#menu"] --- \
		[_ "Collapse nodes#C#menu"] [_ "Join#C#menu"] [_ "Delete#C#menu"] ]
	set MenuCommandsP(2) { {-np- ChangeVariables} { -np- PostDisplay } "" "" "" \
		{-np- CopyMove "Copy" } {utilities list status } "" {utilities id}  {-np- AddEntitiesToMenu %W \
		{.central.s process escape escape escape escape utilities \
		SignalEntities } } {utilities dist} "" "" {utilities collapse} "" "" }
	set MenuAccelerP(2) { Control-p Control-l "" "" "" Control-c "" "" "" "" "" "" "" "" "" "" "" "" }
	set MenuIconsP(2) { "prefs16x16.gif" "layers16x16.gif" "" "" "" "copy16x16.gif" "" \
	    "list16x16.gif" "" "" "" "" "" "" "" "" "" "" }
    }
    
    set MenuEntriesP(2,3) [list [_ "Toolbars#C#menu"]... ---  \
	    [_ "Save window conf#C#menu"]...  [_ "Move Screen Objects#C#menu"] --- \
	    [_ "Read batch window#C#menu"]... \
	    [_ "Perspective#C#menu"]... [_ "Comments#C#menu"]... \
	    [_ "Animation controls#C#menu"]... [_ "Animation script#C#menu"]... \
	    [_ "Macros#C#menu"]... --- [_ "Calculator#C#menu"]... [_ "Report#C#menu"]... \
	    [_ "Notes#C#menu"]...]
    set MenuCommandsP(2,3) { {-np- TOBegin} \
	 "" {-np- SaveWinConfiguration} { -ne- MoveScrObj} "" \
	 {-np- ReadBatch} {-np- PerspectiveW} {-np- CommentsW} \
	 {-np- PostAnimateControls} {-np- ::AutoAnimate::Crear} {-np- toolbarmacros::MacrosWindow} \
	 "" {-np- CalculatorV} { -np- GIDReport::Crear} { -np- OpenNotes}}
    set MenuAccelerP(2,3) { "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIcons(3,5) {"" ""  "" "" "" "" "" "" "" "" "" "" "" "Report16x16.gif" }
    
    set MenuEntriesP(2,7)  [list [_ "Nodes#C#menu"] [_ "Elements#C#menu"]]
    set MenuCommandsP(2,7) { { utilities list nodes} { utilities list elements} }
    
    set MenuEntriesP(2,9) ""
    
    #set MenuEntriesP(2,4) [list [_ "Nodes in Sets#C#menu"] ]
    #set MenuCommandsP(2,4) { { utilities collapse nodesinsets} }

    set MenuEntriesP(2,11) [list [_ "Create#C#menu"] [_ "Delete#C#menu"] [_ "Edit#C#menu"] [_ "ShowBox#C#menu"] ]
    set MenuCommandsP(2,11) { "" {Utilities Dimension Delete} \
	{Utilities Dimension Edit} "" }
    
    set MenuEntriesP(2,11,0) [list [_ "Vertex#C#menu"] [_ "Distance#C#menu"] [_ "Angle#C#menu"] [_ "Radius#C#menu"] [_ "Text#C#menu"] ]
    set MenuCommandsP(2,11,0) { {Utilities Dimension Create Vertex} {Utilities Dimension Create Distance} \
	{Utilities Dimension Create Angle} {Utilities Dimension Create Radius} \
	    {Utilities Dimension Create Text} }
    
    set MenuEntriesP(2,11,3) [list [_ "On#C#menu"] [_ "Off#C#menu"] ]
    set MenuCommandsP(2,11,3) { {Utilities Dimension ShowBox} {Utilities Dimension HideBox} }
    
    set MenuEntriesP(2,14) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] ]
    set MenuCommandsP(2,14) { { utilities join meshes} { utilities join sets} }
    
    set MenuEntriesP(2,15) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] [_ "Cut sets#C#menu"] ]
    set MenuCommandsP(2,15) { {-np- AddMeshSetCutMenu %W \
	    { .central.s process escape escape escape escape utilities delete } volumes} \
	    {-np- AddMeshSetCutMenu %W \
	    { .central.s process escape escape escape escape utilities delete } surfaces} \
	    {-np- AddMeshSetCutMenu %W \
	    { .central.s process escape escape escape escape utilities delete } cuts} \
	}

    set MenuEntriesP(2,15,0) ""
    set MenuEntriesP(2,15,1) ""
    set MenuEntriesP(2,15,2) ""

    if { $GidPriv(Texturas)} {        
	set MenuEntriesP(2,16) [list [_ "View#C#menu"] [_ "Add#C#menu"] [_ "Change#C#menu"] ]
	set MenuCommandsP(2,16) { "" "" ""}
	
	set MenuEntriesP(2,16,0) [list [_ "No#C#menu,Nothing, None#C#menu"] [_ "Fast#C#menu"] [_ "Nice#C#menu"] ]
	set MenuCommandsP(2,16,0) { { utilities texture lit} { utilities texture fast} \
		{ utilities texture nice}}
	
	set MenuEntriesP(2,16,1) [list [_ "Screen map#C#menu"]... [_ "To 4 sided set#C#menu"]... [_ "BoundImg to BoundSet#C#menu"]... ]
	set MenuCommandsP(2,16,1) { { utilities texture addtexture} { utilities texture addto4sided} \
		{ utilities texture addbtob}}
	
	set MenuEntriesP(2,16,2) [list [_ "Flip horiz.#C#menu"] [_ "Flip vert.#C#menu"] ]
	set MenuCommandsP(2,16,2) { { utilities texture flips} { utilities texture flipt}}
    } 

    #-----------------

    set MenuEntriesP(3) [list [_ "Cut Plane#C#menu"] [_ "Divide by selection#C#menu"] \
		             [_ "Divide volume sets#C#menu"] [_ "Divide surface sets#C#menu"] \
		             [_ "Divide lines#C#menu"] [_ "Cut Wire#C#menu"] [_ "Cut Sphere#C#menu"] \
		             [_ "Convert cuts to surface sets#C#menu"] \
		             [_ "Automatically convert cut to set"] ]
    set MenuCommandsP(3) {  ""  { Select Elements} "" "" "" { DoCut CutWire} \
		                { DoCut CutShape Sphere} { DoCut TurnIntoMeshes} \
		                {-np- AutomaticConvertCutToMesh %W 8} }
    set MenuAccelerP(3) {"" "" "" "" "" "" "" "" ""}
    set MenuIconsP(3) {"docut16x16.gif" "" "" "" "" "" "" "" {-np- IconoAutomaticConvertCutToMesh}}

    set MenuEntriesP(3,0) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] [_ "Succesion#C#menu"]]
    set MenuCommandsP(3,0) { { DoCut CutPlane} \
	    { DoCut CutPlane ThreePoints} { DoCut Succesion}}
    set MenuIconsP(3,0) {"cut2p16x16.gif" "cut3p16x16.gif" "cut_succesion16x16.gif"}

    set MenuEntriesP(3,2) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] ]
    set MenuCommandsP(3,2) { { DoCut DivideMesh} \
	    { DoCut DivideMesh ThreePoints} }

    set MenuEntriesP(3,3) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] ]
    set MenuCommandsP(3,3) { { DoCut DivideSets} \
	    { DoCut DivideSets ThreePoints} }

    set MenuEntriesP(3,4) [list [_ "2 points#C#menu"] [_ "3 points#C#menu"] ]
    set MenuCommandsP(3,4) { { DoCut DivideLines} \
	    { DoCut DivideLines ThreePoints} }

    #----------------

    set MenuEntriesP(4) [list [_ "No Results#C#menu"] [_ "No Graphs#C#menu"] --- [_ "Default Analysis/Step#C#menu"] --- \
		             [_ "Contour Fill#C#menu"] [_ "Smooth Contour Fill#C#menu"] \
		             [_ "Contour Lines#C#menu"] [_ "Contour Ranges#C#menu"] [_ "Show Min Max#C#menu"] \
		             [_ "Display Vectors#C#menu"] [_ "Iso Surfaces#C#menu"] [_ "Stream Lines#C#menu"] [_ "Graphs#C#menu"] [_ "Result Surface#C#menu"] \
		             [_ "Deformation#C#menu"] \
		             [_ "Line Diagram#C#menu"] ]
    set MenuCommandsP(4) { { Results Geometry NoResults Geometry Original escape escape escape escape View Label Off} \
	    { Results Graphs OptionsGraph ShowGraphs No} \
	    ""  {-np- AddAnalysisStepsToMenu %W} "" \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results contourfill } "Contour_Fill"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results smoothcontourfill } "Smooth_Contour_Fill"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results contourlines } "Contour_Lines"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results contourranges } "Contour_Ranges"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results shminmax } "Sh_Min_Max"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results displayvectors } "Display_Vectors"} \
	    "" \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results streamlines } "Stream_Lines"} \
	    "" \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results resultsurface } "Result_Surface"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results geometry original geometry deformation } \
	    "Deformation"} \
	    "" }

    set MenuAccelerP(4) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIconsP(4) {"" "" "" "" "" "" "" "" "" "" "" "" "" "" "" "" ""}

    set MenuEntriesP(4,3) { "" }
    set MenuCommandsP(4,3) { "" }

    set MenuEntriesP(4,5) { "" }
    set MenuCommandsP(4,5) { "" }

    set MenuEntriesP(4,6) { "" }
    set MenuCommandsP(4,6) { "" }

    set MenuEntriesP(4,7) { "" }
    set MenuCommandsP(4,7) { "" }

    set MenuEntriesP(4,8) { "" }
    set MenuCommandsP(4,8) { "" }

    set MenuEntriesP(4,9) { "" }
    set MenuCommandsP(4,9) { "" }

    set MenuEntriesP(4,10) { "" }
    set MenuCommandsP(4,10) { "" }

    set MenuEntriesP(4,11) [list [_ "Exact#C#menu"] [_ "Automatic#C#menu"] [_ "Automatic Width#C#menu"] ]
    set MenuCommandsP(4,11) { {-np- AddResultsToMenu %W \
	    {.central.s process escape escape escape escape results isosurfaces exact} "Iso_Surfaces" 1} \
	    {-np- AddResultsToMenu %W \
	    {.central.s process escape escape escape escape results isosurfaces automatic} "Iso_Surfaces" 2} \
	    {-np- AddResultsToMenu %W \
	    {.central.s process escape escape escape escape results isosurfaces automaticwidth} "Iso_Surfaces" 3}}

    set MenuEntriesP(4,11,0) { "" }
    set MenuCommandsP(4,11,0) { "" }

    set MenuEntriesP(4,11,1) { "" }
    set MenuCommandsP(4,11,1) { "" }

    set MenuEntriesP(4,11,2) { "" }
    set MenuCommandsP(4,11,2) { "" }

    set MenuEntriesP(4,12) { "" }
    set MenuCommandsP(4,12) { "" }

    
    set MenuEntriesP(4,13) [list [_ "Clear#C#menu"] [_ "Point evolution#C#menu"] [_ "Point graph#C#menu"] [_ "Border graph#C#menu"] [_ "Line graph#C#menu"]]
    set MenuCommandsP(4,13) { \
	    { Results Graphs OptionsGraph ClearGraphs} \
	    {-np- AddGraphsResultsToMenu %W \
	    {.central.s process escape escape escape escape results graphs pointevolution} "Point_Evolution" } \
	    {-np- AddGraphsXYResultsToMenu %W \
	    {.central.s process escape escape escape escape results graphs pointgraph} "Point_Graph" } \
	    {-np- AddGraphsXYResultsToMenu %W \
	    {.central.s process escape escape escape escape results graphs bordergraph} "Border_Graph" } \
	    {-np- AddGraphsResultsToMenu %W \
	    {.central.s process escape escape escape escape results graphs linegraph} "Line_Graph" }}
    
    set MenuEntriesP(4,13,1) { ""}
    set MenuCommandsP(4,13,1) { ""}

    set MenuEntriesP(4,13,2) { ""}
    set MenuCommandsP(4,13,2) { ""}

    set MenuEntriesP(4,13,3) { ""}
    set MenuCommandsP(4,13,3) { ""}

    set MenuEntriesP(4,13,4) { ""}
    set MenuCommandsP(4,13,4) { ""}

    set MenuEntriesP(4,14) { "" }
    set MenuCommandsP(4,14) { "" }

    set MenuEntriesP(4,15) { "" }
    set MenuCommandsP(4,15) { "" }

    set MenuEntriesP(4,16) [list [_ "Scalar#C#menu"] [_ "Vector#C#menu"] ]
    set MenuCommandsP(4,16) { \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results linediagram scalardiagram } "Scalar_Line_Diagram"} \
	    {-np- AddResultsToMenu %W \
	    {.central.s  process escape escape escape escape results linediagram vectordiagram } "Vector_Line_Diagram"} \
	}

    set MenuEntriesP(4,16,0) { ""}
    set MenuCommandsP(4,16,0) { ""}

    set MenuEntriesP(4,16,1) { ""}
    set MenuCommandsP(4,16,1) { ""}

    #----------------

    set MenuEntriesP(5) [list [_ "Legends#C#menu"] --- [_ "Geometry#C#menu"] [_ "Change Color#C#menu"] [_ "Change Name#C#menu"] --- [_ "Contour#C#menu"] [_ "Vectors#C#menu"] [_ "Iso Surfaces#C#menu"] [_ "Stream Lines#C#menu"] [_ "Graphs#C#menu"] [_ "Result Surface#C#menu"] [_ "Line Diagrams#C#menu"] ]
    set MenuCommandsP(5) { \
			       {-np- PostLegendOptionsMenu %W } \
			       "" "" "" "" "" "" "" \
			       {-np- PostIsosurfaceMenuPrincipal %W } \
			       "" "" "" "" }
    set MenuAccelerP(5) {"" "" "" "" "" "" "" "" "" "" "" "" ""}
    set MenuIconsP(5) {"" "" "" "" "" "" "" "" "" "" "" "" ""}

    set MenuEntriesP(5,0) ""
    set MenuCommandsP(5,0) ""
    
    set MenuEntriesP(5,2) [list [_ "Border Angle#C#menu"] [_ "Massive Body#C#menu"] [_ "Transparent#C#menu"] [_ "Opaque#C#menu"] \
		               [_ "Point options#C#menu"]... [_ "Line options#C#menu"]... [_ "Covering mesh#C#menu"] ]
   
    set MenuCommandsP(5,2) [list \
	    {Results Options BorderAngle} \
	    {Results Options MassiveBody} \
	    {Utilities Render transparent} \
	    {Utilities Render opaque} \
	    {-np- PostPointOptions} \
	    [list -np- PostLineOptions LineSize LineDetail info_tamanno_linea [_ "Line options#C#menu"]] \
	    {Results Options ShowCoverMesh}]

    set MenuEntriesP(5,3) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] [_ "Cut sets#C#menu"] ]
    set MenuCommandsP(5,3) [list \
	    [list -np- AddPostGeomToMenu %W \
	    {.central.s process escape escape escape escape utilities changecolor volumes} volumes \
	    {Ambient Diffuse Specular Shininess Transparency Default} \
	    [list [_ "Ambient#C#menu"] [_ "Diffuse#C#menu"] [_ "Specular#C#menu"] [_ "Shininess#C#menu"] \
		 [_ "Transparency#C#menu"] [_ "Default#C#menu"]] \
	    ]\
	    [list -np- AddPostGeomToMenu %W \
	    {.central.s process escape escape escape escape utilities changecolor surfaces} surfaces \
	    "Ambient Diffuse Specular Shininess Transparency Default" \
            [list [_ "Ambient#C#menu"] [_ "Diffuse#C#menu"] [_ "Specular#C#menu"] [_ "Shininess#C#menu"] \
            [_ "Transparency#C#menu"] [_ "Default#C#menu"]] \
	    ]\
	    [list -np- AddPostGeomToMenu %W \
	    {.central.s process escape escape escape escape utilities changecolor cuts} cuts \
	     "Ambient Diffuse Specular Shininess Transparency Default" \
            [list [_ "Ambient#C#menu"] [_ "Diffuse#C#menu"] [_ "Specular#C#menu"] [_ "Shininess#C#menu"] \
            [_ "Transparency#C#menu"] [_ "Default#C#menu"]] \
	    ]]

    set MenuEntriesP(5,3,0) { ""}
    set MenuCommandsP(5,3,0) { ""}

    set MenuEntriesP(5,3,1) { ""}
    set MenuCommandsP(5,3,1) { ""}

    set MenuEntriesP(5,3,2) { ""}
    set MenuCommandsP(5,3,2) { ""}

    set MenuEntriesP(5,4) [list [_ "Volume sets#C#menu"] [_ "Surface sets#C#menu"] [_ "Cut sets#C#menu"] ]
    set MenuCommandsP(5,4) { {-np- AddPostGeomToMenu %W \
	    {.central.s process escape escape escape escape utilities changename volumes} volumes \
	    "" "" } \
	    {-np- AddPostGeomToMenu %W \
	    {.central.s process escape escape escape escape utilities changename surfaces} surfaces \
	    "" "" } \
	    {-np- AddPostGeomToMenu %W \
	    {.central.s process escape escape escape escape utilities changename cuts} cuts \
	    "" "" } }
	    
    set MenuEntriesP(5,4,0) { ""}
    set MenuCommandsP(5,4,0) { ""}

    set MenuEntriesP(5,4,1) { ""}
    set MenuCommandsP(5,4,1) { ""}

    set MenuEntriesP(5,4,2) { ""}
    set MenuCommandsP(5,4,2) { ""}
    
    set MenuEntriesP(5,6) [list [_ "Number of Colors#C#menu"] [_ "Width Intervals#C#menu"] \
		               [_ "Set Limits#C#menu"] [_ "Define Limits#C#menu"]... \
		               [_ "Reset Limit Values#C#menu"] [_ "Reset All#C#menu"] \
		               [_ "Max Options#C#menu"] [_ "Min Options#C#menu"] \
		               [_ "Color Scale#C#menu"] [_ "Smoothing type#C#menu"] \
		               [_ "Bright color#C#menu"] [_ "Color window#C#menu"]... ]
    set MenuCommandsP(5,6) { \
	    { Results ContOptions NumberOfColor} \
	    { Results ContOptions FixIntervals} \
	    "" \
	    { -np- PostContLimitsWin} \
	    { Results ContOptions SetMaxOptions ResetValue escape escape escape escape \
	    Results ContOptions SetMinOptions ResetValue escape escape escape escape \
	    Utilities Redisplay} \
	    { Results ContOptions SetMaxOptions ResetValue escape \
	    SetMinOptions ResetValue escape \
	    NumberOfColors 50 \
	    SetMinOptions MinColor Standard escape \
	    SetMaxOptions MaxColor Standard escape \
	    ColorRamp Tangent escape escape escape escape escape \
	    Utilities Redisplay } \
	    "" "" {-np- PostContourWhichScaleMenu %W} {-np- PostSmoothContourTypeMenu %W} \
	      { -np- PostContourBrightColorMenu %W} {-np- PostContourColors}}
    set MenuIconsP(5,6) { "" "" "" "" "resetminmax16x16.gif" "" "" "" "" "" ""}
    
    set MenuEntriesP(5,6,2) [list [_ "Shown Sets for This Step#C#menu"] [_ "All Sets for This Step#C#menu"] \
		                 [_ "Shown Sets for All Steps#C#menu"] [_ "All Sets for All Steps#C#menu"] ]
    set MenuCommandsP(5,6,2) { \
	    { Results ContOptions WhichContLimit ShownSets \
	    escape escape escape escape Utilities Redisplay } \
	    { Results ContOptions WhichContLimit AllSets\
	    escape escape escape escape Utilities Redisplay } \
	    { Results ContOptions FixAnalysisLim \
	    escape escape escape escape Utilities Redisplay } \
	    { Results ContOptions FixAbsLimits \
	    escape escape escape escape Utilities Redisplay } }
   

    set MenuEntriesP(5,6,6) [list [_ "Reset Value#C#menu"] [_ "Out Max Color#C#menu"] [_ "Def. Max Color#C#menu"] [_ "Set Value#C#menu"] ]
    set MenuCommandsP(5,6,6) { \
	    { Results ContOptions SetMaxOptions ResetValue\
	    escape escape escape escape Utilities Redisplay } \
	    { -np- PostOutMinMaxColourMenu %W Max} \
	    { Results ContOptions SetMaxOptions MaxColor User} \
		 { Results ContOptions SetMaxOptions SetValue} }
    set MenuIconsP(5,6,6) {"" "" "" "usermax16x16.gif"}
    
    set MenuEntriesP(5,6,6,1) ""
    set MenuCommandsP(5,6,6,1) ""


    set MenuEntriesP(5,6,7) [list [_ "Reset Value#C#menu"] [_ "Out Min Color#C#menu"] [_ "Def. Min Color#C#menu"] [_ "Set Value#C#menu"] ]
    set MenuCommandsP(5,6,7) { \
	    { Results ContOptions SetMinOptions ResetValue\
	    escape escape escape escape Utilities Redisplay } \
	    { -np- PostOutMinMaxColourMenu %W Min} \
	    { Results ContOptions SetMinOptions MinColor User} \
	    { Results ContOptions SetMinOptions SetValue} }
    set MenuIconsP(5,6,7) {"" "" "" "usermin16x16.gif"}
    
    set MenuEntriesP(5,6,7,1) ""
    set MenuCommandsP(5,6,7,1) ""

    set MenuEntriesP(5,6,8) ""
    set MenuCommandsP(5,6,8) ""

    set MenuEntriesP(5,6,9) ""
    set MenuCommandsP(5,6,9) ""

    set MenuEntriesP(5,6,10) ""
    set MenuCommandsP(5,6,10) ""

#     set MenuEntriesP(5,7) [list [_ "Display Style#C#menu"] [_ "Render#C#menu"] [_ "Transparency#C#menu"] [_ "Convert to cuts#C#menu"] ]
#     set MenuCommandsP(5,7) { \
#             {-np- PostIsoSurfaceOptionsMenu %W DisplayStyle} \
#             {-np- PostIsoSurfaceOptionsMenu %W Render} \
#             {-np- PostIsoSurfaceOptionsMenu %W Transparency} \
#             { Results isosurfaces TurnIntoCuts } }

    set MenuEntriesP(5,7) [list [_ "Interior/All vectors#C#menu"] [_ "Number of Colors#C#menu"] \
			       [_ "Color Mode#C#menu"] [_ "Offset#C#menu"] \
			       [_ "Change Color (mono)#C#menu"] [_ "Detail#C#menu"] \
			       [_ "Size#C#menu"] [_ "Filter factor"] ]
    set MenuCommandsP(5,7) { \
				 { Results Options AllVectors} \
				 { Results Options VectorNumCols} \
				 { Results Options VectorColour} \
				 { Results Options VectorOffset} \
				 { Results Options VMonoColor} \
				 {-np- PostVectorsDetailMenu %W } \
				 {-np- PostVectorsSizeMenu %W } \
				 { Results Options VectorFilterFactor} \
			     }

    set MenuEntriesP(5,7,5) ""
    set MenuCommandsP(5,7,5) ""

    set MenuEntriesP(5,7,6) ""
    set MenuCommandsP(5,7,6) ""

    set MenuEntriesP(5,8) ""
    set MenuCommandsP(5,8) ""

#     set MenuEntriesP(5,8) [list [_ "Display Style#C#menu"] [_ "Transparency#C#menu"] \
# 			       [_ "Color Mode#C#menu"] [_ "Change color#C#menu"] \
# 			       [_ "Convert to cuts#C#menu"] [_ "Draw always#C#menu"] \
# 			       [_ "Show isolines#C#menu"]]
#     set MenuCommandsP(5,8) { \
# 	    {-np- PostIsoSurfaceOptionsMenu %W DisplayStyle} \
# 	    {-np- PostIsoSurfaceOptionsMenu %W Transparency} \
# 	    {-np- PostIsoSurfaceOptionsMenu %W Color} \
# 	    { Results isosurfaces DisplayStyle ChangeMonoColour } \
# 	    { Results isosurfaces TurnIntoCuts } \
# 	    {-np- PostIsoSurfaceAlwaysDrawn %W 5}\
# 	    {-np- PostIsoSurfaceDrawIsolines %W 6}}
# 	
#     set MenuEntriesP(5,8,0) ""
#     set MenuCommandsP(5,8,0) ""
# 
#     set MenuEntriesP(5,8,1) ""
#     set MenuCommandsP(5,8,1) ""
# 
#      set MenuEntriesP(5,8,2) ""
#      set MenuCommandsP(5,8,2) ""

    set MenuEntriesP(5,9) [ list [_ "Change color#C#menu"] [_ "Color Mode#C#menu"] [_ "Delete#C#menu"] \
		                [_ "Label#C#menu"] [_ "Size & detail#C#menu"]... \
		                [_ "Set initial step#C#menu"] \
		                [_ "Set max length#C#menu"] [_ "Set max points#C#menu"] [_ "Set initial rotation#C#menu"]]
    set MenuCommandsP(5,9) { 
	{ Results Options StreamColor ChangeMonoColour}
	{-np- PostStreamLinesColorOptionsMenu %W }
	{ Results Options StreamDelete }
	{ Results Options StreamLabel }
	{-np- PostStreamLineOptions }
	{ Results Options StreamIniStep}
	{ Result Options StreamLength}
	{ Results Options StreamMaxPoints}
	{ Results Options StLineIniRotation}
    }
    
    set MenuEntriesP(5,9,1) ""
    set MenuCommandsP(5,9,1) ""

    set MenuEntriesP(5,10) [list [_ "Outline on model#C#menu"] [_ "Grids#C#menu"] [_ "Current style#C#menu"] [_ "Change style graph#C#menu"] \
		                [_ "Change color graph#C#menu"] [_ "Change line width#C#menu"] [_ "Change line pattern#C#menu"] \
		                [_ "Change pattern factor#C#menu"] [_ "Change point size#C#menu"] [_ "Change title graph#C#menu"] \
		                [_ "Invert graph sense#C#menu"] [_ "Delete graph#C#menu"] [_ "Title#C#menu"] \
		                [_ "Reset axis values#C#menu"] [_ "X axis#C#menu"] [_ "Y axis#C#menu"] [_ "Clear graphs#C#menu"]]
    set MenuCommandsP(5,10)  { \
	    { Results Graphs OptionsGraph GraphOutlineOnModel } \
	    { Results Graphs OptionsGraph Grids} \
	    { Results Graphs OptionsGraph CurrentStyle} \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph stylegraphs} 1 } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph colorgraphs} 1 } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph linewidthgraphs} 1 } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph patterngraphs} 1 } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph patternfactor} 1 } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph pointsize} 1 } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph titlegraphs} } \
	    {-np- AddLineGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph InvertLineGraph} } \
	    {-np- AddGraphsToMenu %W { .central.s process escape escape escape escape results graphs optionsgraph deletegraph} } \
	    "" \
	    { Results Graphs OptionsGraph X_Axis Reset Y_Axis Reset} "" "" \
	    { Results Graphs OptionsGraph Clear} }

    set MenuEntriesP(5,10,3) { ""}
    set MenuCommandsP(5,10,3) { ""}

    set MenuEntriesP(5,10,4) { ""}
    set MenuCommandsP(5,10,4) { ""}

    set MenuEntriesP(5,10,5) { ""}
    set MenuCommandsP(5,10,5) { ""}

    set MenuEntriesP(5,10,6) { ""}
    set MenuCommandsP(5,10,6) { ""}

    set MenuEntriesP(5,10,7) { ""}
    set MenuCommandsP(5,10,7) { ""}

    set MenuEntriesP(5,10,8) { ""}
    set MenuCommandsP(5,10,8) { ""}

    set MenuEntriesP(5,10,9) { ""}
    set MenuCommandsP(5,10,9) { ""}

    set MenuEntriesP(5,10,10) { ""}
    set MenuCommandsP(5,10,10) { ""}

    set MenuEntriesP(5,10,11) { ""}
    set MenuCommandsP(5,10,11) { ""}

    set MenuEntriesP(5,10,12) [list [_ "Change text#C#menu"] [_ "Change position#C#menu"] [_ "Reset#C#menu"] ]
    set MenuCommandsP(5,10,12) { { Results Graphs OptionsGraph MainTitle} \
	    { Results Graphs OptionsGraph Legend2Title}  \
	    { Results Graphs OptionsGraph MainTitle "''"}}

    set MenuEntriesP(5,10,14) [list [_ "Reset#C#menu"] [_ "Set min value#C#menu"] [_ "Set max value#C#menu"] [_ "Set divisions#C#menu"] [_ "Set label#C#menu"] ]
    set MenuCommandsP(5,10,14) { { Results Graphs OptionsGraph X_Axis Reset } \
	    { Results Graphs OptionsGraph X_Axis SetMin} \
	    { Results Graphs OptionsGraph X_Axis SetMax} \
	    { Results Graphs OptionsGraph X_Axis SetDivisions} \
	    { Results Graphs OptionsGraph X_Axis SetLabel}}

    set MenuEntriesP(5,10,15) [list [_ "Reset#C#menu"] [_ "Set min value#C#menu"] [_ "Set max value#C#menu"] [_ "Set divisions#C#menu"] [_ "Set label#C#menu"] ]
    set MenuCommandsP(5,10,15) { { Results Graphs OptionsGraph Y_Axis Reset } \
	    { Results Graphs OptionsGraph Y_Axis SetMin} \
	    { Results Graphs OptionsGraph Y_Axis SetMax} \
	    { Results Graphs OptionsGraph Y_Axis SetDivisions} \
	    { Results Graphs OptionsGraph Y_Axis SetLabel}}


    set MenuEntriesP(5,11) [list [_ "Show elevations#C#menu"] ]
    set MenuCommandsP(5,11) { { -np- PostResultSurfaceOptionsMenu %W } }
    
    set MenuEntriesP(5,11,0) ""
    set MenuCommandsP(5,11,0) ""
   
    set MenuEntriesP(5,12) [list [_ "Show elevations#C#menu"] ]
    set MenuCommandsP(5,12) { { -np- PostDiagramOptionsMenu %W } }

    set MenuEntriesP(5,12,0) ""
    set MenuCommandsP(5,12,0) ""
      
    #----------------

    set MenuEntriesP(6) [list [_ "View style#C#menu"]... [_ "View results#C#menu"]... [_ "Animate#C#menu"]... \
		         --- [_ "View graphs#C#menu"]... [_ "Several Results#C#menu"]... \
		             [_ "Results ranges table#C#menu"]... [_ "Create Result"]...  ]
#[_ "Create Result 2"]...
    set MenuCommandsP(6) { {-np- PostDisplay} {-np- PostGeom::Create} 
	{-np- PostAnimateM} {} {-np- PostGraphs::Create} {-np- PostVariosResultados} 
	{-np- PostRangesTable::Create} {-np- PostCreateResult}}
# {-np- PCreateResult::Crear}
    #PostGraphs::Create instead PostGraphResultsWindow

    set MenuAccelerP(6) { Control-s Control-d Control-m "" "" "" "" ""}
# ""
    set MenuIconsP(6) { "" "" "" "" "" "" "" ""}
# ""

    #----------------

    set MenuEntriesP(7) [list [_ "Help#C#menu"]... [_ "Customization Help#C#menu"]... [_ "Tutorials#C#menu"]... \
	    [_ "What is new#C#menu"]... [_ "FAQ#C#menu"]... --- [_ "Register GiD#C#menu"]... [_ "Register Problem type#C#menu"]... \
	    --- [_ "Visit %s web" $::GidPriv(ProgName)]... [_ "About#C#menu"]... ]
    set MenuCommandsP(7) [list {-np- GiDHelpWindow -type REFERENCE -start html-version} \
	    {-np- GiDHelpWindow  -type REFERENCE -start html-customization} \
	    { -np- CreateTutorial_win} { -np- GiDHelpWindow -type REFERENCE -start html_whatsnew} \
	    {-np- GiDHelpWindow -type REFERENCE -start html-faq} "" {-np- gidregister} \
	    {-np- gidregister module} "" "-np- VisitWeb $GidPriv(ProgWeb)" {-np- CreateWelcomeWin} ]
    set MenuAccelerP(7) {F1 "" "" "" "" "" "" "" ""}
    set MenuIconsP(7) {"help16x16.gif" "" "" "" "" "" "" "" ""}
}

#-----------------------------------------------------------

proc SetBitmapNamesP {} {
    global BitMapsNamesP BitMapsCommandsP BitmapsHelpP GidPriv

    catch { unset BitMapsNamesP BitMapsCommandsP BitmapsHelpP }

   
    if { !$GidPriv(separadores)} {
	set BitMapsNamesP(0) { zoomin.gif zoomout.gif zframe.gif redraw.gif \
				   rotate.gif pan.gif lightpos.gif \
				   displaystyle.gif cullstyle.gif meshes.gif sets.gif cuts.gif \
				   docut.gif usermax.gif usermin.gif resetminmax.gif list.gif}
    } else {
	set BitMapsNamesP(0) { zoomin.gif zoomout.gif zframe.gif redraw.gif \
				   rotate.gif pan.gif --- lightpos.gif \
				   displaystyle.gif cullstyle.gif --- meshes.gif sets.gif cuts.gif --- \
				   docut.gif --- usermax.gif usermin.gif resetminmax.gif list.gif}
    }
   
    #dividemesh dividesets 

    if { !$GidPriv(separadores)} {
	set BitMapsCommandsP(0) { {-ne- zoom in} {-ne- zoom out} {-ne- zoom frame} \
		{-ne- redraw} {-ne- rotate trackball} {-ne- dynamicpan } \
		{ utilities render changelightvec} \
		{-np- AddBitmapsToDisplayStyle %W \
		{ .central.s process escape escape escape escape displaystyle}} \
		{-np- AddBitmapsToCullStyle %W \
		{ .central.s process escape escape escape escape utilities render culling}} \
		{-np- AddBitmapsToMeshSetCut %W \
		{ .central.s process escape escape escape escape Select} volumesets} \
		{-np- AddBitmapsToMeshSetCut %W \
		{ .central.s process escape escape escape escape Select} surfacesets} \
		{-np- AddBitmapsToMeshSetCut %W \
		{ .central.s process escape escape escape escape Select} cutsets} \
		{-np- AddBitmapsToCutDivide %W \
		{ .central.s process escape escape escape escape DoCut} CutPlane} \
		{-np- PostContLimitsMaxEntry %W } \
		{-np- PostContLimitsMinEntry %W } \
		{ Results ContOptions SetMaxOptions ResetValue escape escape escape escape \
		Results ContOptions SetMinOptions ResetValue escape escape escape escape \
		Utilities Redisplay }  \
		{-np- AddBitmapsToMenu %W {.central.s process \
		escape escape escape escape utilities list }}
	    }

	#             {-np- AddBitmapsToCutDivide %W \
		#             { .central.s process escape escape escape escape DoCut} DivideMesh} \
		#             {-np- AddBitmapsToCutDivide %W \
		#             { .central.s process escape escape escape escape DoCut} DivideSets}
	
	set BitmapsHelpP(0) [list [_ "Zoom in#C#menu"] [_ "Zoom out#C#menu"] [_ "Zoom frame#C#menu"] [_ "Redraw#C#menu"] \
		                 [_ "Rotate trackball#C#menu"] [_ "Pan#C#menu"] [_ "Change light vector direction#C#menu"] \
		                 [_ "Display Style#C#menu"] [_ "Culling Style#C#menu"] \
		                 [_ "Switch Volume set On/Off#C#menu"] \
		                 [_ "Switch Surface set On/Off#C#menu"] [_ "Switch Cut set On/Off#C#menu"] \
		                 [_ "Cut Volume/Surface sets with 2/3 points, succesion#C#menu"] [_ "Set maximum value#C#menu"] \
		                 [_ "Set minimum value#C#menu"] [_ "Reset Contour Limit Values#C#menu"] [_ "List Entities#C#menu"] ]
	#"Divide Mesh with 2/3 points" \
		#            "Divide Sets with 2/3 points"

	set BitMapsNamesP(0,7) { boundaries.gif hiddenbound.gif alllines.gif hiddenlines.gif body.gif bodybound.gif \
				     bodylines.gif points.gif pointsbound.gif}
	set BitMapsCommandsP(0,7) { boundaries hiddenbound alllines hiddenlines body bodybound bodylines points pointsbound}

	set BitMapsNamesP(0,8) { cullnone.gif cullfrontfaces.gif cullbackfaces.gif}
	set BitMapsCommandsP(0,8) { none frontfaces backfaces}

	set BitMapsNamesP(0,9) { volumesets.gif}
	set BitMapsCommandsP(0,9) { volumesets}

	set BitMapsNamesP(0,10) { surfacesets.gif}
	set BitMapsCommandsP(0,10) { surfacesets}

	set BitMapsNamesP(0,11) { cutsets.gif}
	set BitMapsCommandsP(0,11) { cutsets}

	set BitMapsNamesP(0,12) { cut2p.gif cut3p.gif}
	set BitMapsCommandsP(0,12) { cut2p cut3p}

	#set BitMapsNamesP(0,14) { cut2p.gif cut3p.gif}
	#set BitMapsCommandsP(0,14) { cut2p cut3p}
	#
	#set BitMapsNamesP(0,15) { cut2p.gif cut3p.gif}
	#set BitMapsCommandsP(0,15) { cut2p cut3p}

	set BitMapsNamesP(0,16) { }
	set BitMapsCommandsP(0,16) { }

    } else {
	# con separadores

	set BitMapsCommandsP(0) { {-ne- zoom in} {-ne- zoom out} {-ne- zoom frame} \
		{-ne- redraw} {-ne- rotate trackball} {-ne- dynamicpan } "" \
		{ utilities render changelightvec} \
		{-np- AddBitmapsToDisplayStyle %W \
		{ .central.s process escape escape escape escape displaystyle}} \
		{-np- AddBitmapsToCullStyle %W \
		{ .central.s process escape escape escape escape utilities render culling}} \
		"" {-np- AddBitmapsToMeshSetCut %W \
		{ .central.s process escape escape escape escape Select} volumesets} \
		{-np- AddBitmapsToMeshSetCut %W \
		{ .central.s process escape escape escape escape Select} surfacesets} \
		{-np- AddBitmapsToMeshSetCut %W \
		{ .central.s process escape escape escape escape Select} cutsets} \
		"" {-np- AddBitmapsToCutDivide %W \
		{ .central.s process escape escape escape escape DoCut} CutPlane} \
		"" {-np- PostContLimitsMaxEntry %W } \
		{-np- PostContLimitsMinEntry %W }\
		{ Results ContOptions SetMaxOptions ResetValue escape escape escape escape \
		Results ContOptions SetMinOptions ResetValue escape escape escape escape \
		Utilities Redisplay }  \
		{-np- AddBitmapsToMenu %W {.central.s process \
		escape escape escape escape utilities list } "list" }
	    }

	#             {-np- AddBitmapsToCutDivide %W \
		#             { .central.s process escape escape escape escape DoCut} DivideMesh} \
		#             {-np- AddBitmapsToCutDivide %W \
		#             { .central.s process escape escape escape escape DoCut} DivideSets}

	set BitmapsHelpP(0) [list [_ "Zoom in#C#menu"] [_ "Zoom out#C#menu"] [_ "Zoom frame#C#menu"] [_ "Redraw#C#menu"] \
		                  [_ "Rotate trackball#C#menu"] [_ "Pan#C#menu"] "" [_ "Change light vector direction#C#menu"] \
		                 [_ "Display Style#C#menu"] [_ "Culling Style#C#menu"] \
		                 "" [_ "Switch Volume sets On/Off#C#menu"] \
		                 [_ "Switch Surface set On/Off#C#menu"] [_ "Switch Cut set On/Off#C#menu"] \
		                 "" [_ "Cut Volume/Surface sets with 2/3 points, succesion#C#menu"] "" \
		                  [_ "Set maximum value#C#menu"] [_ "Set minimum value#C#menu"] \
		                  [_ "Reset Contour Limit Values#C#menu"] [_ "List Entities#C#menu"] ]
	#"Divide Mesh with 2/3 points" \
		#            "Divide Sets with 2/3 points"

	set BitMapsNamesP(0,8) { boundaries.gif hiddenbound.gif alllines.gif hiddenlines.gif body.gif bodybound.gif \
				     bodylines.gif points.gif pointsbound.gif}
	set BitMapsCommandsP(0,8) { boundaries hiddenbound alllines hiddenlines body bodybound bodylines points pointsbound}

	set BitMapsNamesP(0,9) { cullnone.gif cullfrontfaces.gif cullbackfaces.gif}
	set BitMapsCommandsP(0,9) { none frontfaces backfaces}

	set BitMapsNamesP(0,11) { volumesets.gif}
	set BitMapsCommandsP(0,11) { volumesets}

	set BitMapsNamesP(0,12) { surfacesets.gif}
	set BitMapsCommandsP(0,12) { surfacesets}

	set BitMapsNamesP(0,13) { cutsets.gif}
	set BitMapsCommandsP(0,13) { cutsets}

	set BitMapsNamesP(0,15) { cut2p.gif cut3p.gif}
	set BitMapsCommandsP(0,15) { cut2p cut3p}

	#set BitMapsNamesP(0,15) { cut2p.gif cut3p.gif}
	#set BitMapsCommandsP(0,15) { cut2p cut3p}
	#
	#set BitMapsNamesP(0,16) { cut2p.gif cut3p.gif}
	#set BitMapsCommandsP(0,16) { cut2p cut3p}

	set BitMapsNamesP(0,20) { }
	set BitMapsCommandsP(0,20) { }

    }
}

proc SetAllMenusVariables {} {
    global GidPriv
    
    SetMenusVariables
    SetBitmapNames
    Set3dButtonVariables
    SetMenusVariablesP
    SetBitmapNamesP
    #DWInitUserDataOptions
}

proc ClearMenu { w } {
    set lastentry [$w index last]
    if { $lastentry == "none" } {
	return
    }
    for { set i 0 } { $i <= $lastentry } { incr i } {
	if { [$w type $i] == "cascade" } {
	    set wchild [$w entrycget $i -menu]
	    ClearMenu $wchild
	    destroy $wchild
	}
    }
    $w delete 0 last
}


proc SwapCopyMove { {mode "Copy"} } {  
    set w .gid.wcopymove
    if { [winfo exist $w] } { 
       destroy $w
    } else {
       CopyMove $mode
    }
}

proc SwapChangeVariables { } {  
    set w .gid.wvar
    if { [winfo exist $w] } { 
       destroy $w
    } else {
	ChangeVariables
    }
}

proc SwapChangeLayers { } {    
    if { [catch { set whatuse [lindex [.central.s info Project] 4] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	#preprocess
	set w .gid.wlay
	if { [winfo exist $w] } { 
	   destroy $w
	} else {
	  ChangeLayers
	}
    } else {
	#postprocess
	set w .gid.wPostDisplay
	if { [winfo exist $w] } { 
	   destroy $w
	} else {
	  PostDisplay
	}
    }
}

proc SwapHelpWindow { {help_type "REFERENCE"} {dir "" } } {  
    set w .gid.help_win
    if { [winfo exist $w] } { 
       destroy $w
    } else {
       HelpWindow $help_type $dir
    }
}


proc StdBitmaps { { what "DEFAULT" }} {
    global StdBitmapsNames StdBitmapsCommands StdBitmapsHelp GIDDEFAULT
    global GidPriv
    set StdBitmapsNames(0) "new.gif open2.gif save.gif --- viewprev.gif viewnext.gif viewlist.gif --- camera.gif print.gif --- \
	    prepost.gif copy.gif layer.gif --- prefs.gif help.gif --- exit.gif \
	    $GidPriv(InfoGiDBitmapName)"
    set GidPriv(InfoGiDBitmapsWidth) 77
    set GidPriv(InfoGiDBitmapsHeight) 24

    
    if { [catch { set whatuse [lindex [.central.s info Project] 4] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
	#preprocess   
	set StdBitmapsCommands(0) [list { files new} { files read} { files save} "" \
		                       {-ne- zoom previous} {-ne- zoom next} {-np- AddRecentViewFiles2IconBar %W } ""\
		                       {-np- AddBitmapsToCamera %W { .central.s process hardcopy } } \
		                       {-np- HardcopyToPrint {Hardcopy PS}} "" {-np- TogglePrePost} \
		                       {-np- SwapCopyMove "Copy"} {-np- SwapChangeLayers} "" \
		                        {-np- SwapChangeVariables } {-np- GiDHelpWindow -type REFERENCE -start html-version} "" Quit \
		                       "-np- $GidPriv(InfoGiDProc)"]
	
	set StdBitmapsHelp(0) [list [_ "New GiD project"] [_ "Open GiD project"] [_ "Save GiD project"] \
		                   "" [_ "Previous view"] [_ "Next view"] [_ "List of views"] "" \
		                   [_ "Take a snapshot"] [_ "Print current view"] "" \
		                    [_ "Toggle between pre and postprocess"] [_ "Copy/Transform"] \
		                    [_ "Layers"] "" [_ "Preferences"] [_ "Help"] "" [_ "Exit GiD"] [_ "GiD Info"] ]
       } else {
	#postprocess
	   set StdBitmapsCommands(0) [list { files new} { files read} { files saveall binmeshessets} "" \
		                          {-ne- zoom previous} {-ne- zoom next} {-np- AddRecentViewFiles2IconBar %W } ""\
		                          {-np- AddBitmapsToCamera %W { .central.s process hardcopy } } \
		                          {-np- HardcopyToPrint {Hardcopy PS}} "" {-np- TogglePrePost} \
		                          {-np- SwapCopyMove "Copy"} {-np- SwapChangeLayers} "" \
		                           {-np- SwapChangeVariables } {-np- GiDHelpWindow -type REFERENCE -start html-version} "" Quit \
		                          "-np- $GidPriv(InfoGiDProc)"]
	   
	   set StdBitmapsHelp(0) [list [_ "Clean postprocess"] [_ "Open Postprocess file"] [_ "Export binary postprocess"] \
		                      "" [_ "Previous view"] [_ "Next view"] [_ "List of views"] "" \
		                      [_ "Take a snapshot"] [_ "Print current view"] "" \
		                      [_ "Toggle between pre and postprocess"] [_ "Copy/Transform"] \
		                      [_ "View style"] "" [_ "Preferences"] [_ "Help"] "" [_ "Exit GiD"] [_ "GiD Info"] ] 
       }




    set StdBitmapsNames(0,6) {}
    set StdBitmapsCommands(0,6) {}

    set StdBitmapsNames(0,8) { eps.gif ps.gif bmp.gif gif.gif jpeg.gif png.gif tga.gif tiff.gif vrml.gif}
    set StdBitmapsCommands(0,8) { eps ps bmp gif jpeg png tga tiff vrml}

    CreateOtherBitmaps StdBar [_ "Standard Bar"] StdBitmapsNames StdBitmapsCommands \
	    StdBitmapsHelp $GIDDEFAULT/bitmaps StdBitmaps $what PrePost
    AddNewToolbar "Standard bar" PrePostStdBarWindowGeom StdBitmaps [_ "Standard bar"]

}

proc ViewResultsBarBitmaps { { what "DEFAULT"}} {
    global ViewResultsBarBitmapsNames ViewResultsBarBitmapsCommands ViewResultsBarBitmapsHelp GIDDEFAULT
    global GidPriv
    set ViewResultsBarBitmapsNames(0) [ list PostBarNoResult.gif postgraf.gif --- PostBarAnalysisStep.gif --- \
		                            PostBarContourFill.gif PostBarContourLines.gif PostBarShMinMax.gif \
		                            PostBarVectors.gif PostBarIsoSurfaces.gif PostBarStreamLines.gif \
		                            PostBarResultSurface.gif PostBarDeformation.gif --- \
		                            PostBarGraphPointEvolution.gif PostBarGraphLine.gif \
		                            PostBarGraphPointGraph.gif PostBarGraphBorder.gif \
		                            PostBarGraphClear.gif
		                       ]
    set GidPriv(InfoGiDBitmapsWidth) 24
    set GidPriv(InfoGiDBitmapsHeight) 24

    
    if { [catch { set whatuse [lindex [.central.s info Project] 4] }] } {
	set whatuse GEOMETRYUSE
    }
    if { ( $whatuse == "GEOMETRYUSE") || ( $whatuse == "MESHUSE") } {
    } else {
	#postprocess
	set ViewResultsBarBitmapsCommands(0) [list { Results Geometry NoResults Geometry Original escape escape escape escape View Label Off} \
		                           {-np- TogglePostGraph} \
		                           {} \
		                           {-np- AddAnalysisStepsToMenu %W} \
		                           {} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results contourfill } \
		                                "Contour_Fill"} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results contourlines } \
		                                "Contour_Lines"} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results shminmax } \
		                                "Sh_Min_Max"} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results displayvectors } \
		                                "Display_Vectors"} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results isosurfaces exact} \
		                                "Iso_Surfaces" 1} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results streamlines } \
		                                "Stream_Lines"} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results resultsurface } \
		                                "Result_Surface"} \
		                           {-np- AddResultsToMenu %W \
		                                { .central.s process escape escape escape escape results geometry original geometry deformation } \
		                                "Deformation"} \
		                           {} \
		                           {-np- AddGraphsResultsToMenu %W \
		                                {.central.s process escape escape escape escape results graphs pointevolution} \
		                                "Point_Evolution" } \
		                           {-np- AddGraphsResultsToMenu %W \
		                                {.central.s process escape escape escape escape results graphs linegraph} \
		                                "Line_Graph" } \
		                           {-np- AddGraphsXYResultsToMenu %W \
		                                {.central.s process escape escape escape escape results graphs pointgraph} \
		                                "Point_Graph" } \
		                           {-np- AddGraphsXYResultsToMenu %W \
		                                {.central.s process escape escape escape escape results graphs bordergraph} \
		                                "Border_Graph" } \
		                           { Results Graphs OptionsGraph ClearGraphs}
		                          ]
	
	set ViewResultsBarBitmapsHelp(0) [list [_ "No results#C#menu"] [_ "Toggle mesh and graphs view#C#menu"] {} \
		                       [_ "Default Analysis/Step#C#menu"] {} \
		                       [_ "Contour fill#C#menu"] [_ "Contour lines#C#menu"] [_ "Show min max#C#menu"] \
		                       [_ "Display vectors#C#menu"] [_ "Iso surfaces#C#menu"] [_ "Stream lines#C#menu"] \
		                       [_ "Result surface#C#menu"] [_ "Deformation#C#menu"] {} \
		                       [_ "Point evolution#C#menu"] [_ "Line graph#C#menu"] \
		                       [_ "Point graph#C#menu"] [_ "Border graph#C#menu"] \
		                       [_ "Clear graphs#C#menu"] \
		                      ] 

	set ViewResultsBarBitmapsNames(0,3) ""
	set ViewResultsBarBitmapsCommands(0,3) ""
	set ViewResultsBarBitmapsNames(0,5) ""
	set ViewResultsBarBitmapsCommands(0,5) ""
	set ViewResultsBarBitmapsNames(0,6) ""
	set ViewResultsBarBitmapsCommands(0,6) ""
	set ViewResultsBarBitmapsNames(0,7) ""
	set ViewResultsBarBitmapsCommands(0,7) ""
	set ViewResultsBarBitmapsNames(0,8) ""
	set ViewResultsBarBitmapsCommands(0,8) ""
	set ViewResultsBarBitmapsNames(0,9) ""
	set ViewResultsBarBitmapsCommands(0,9) ""
	set ViewResultsBarBitmapsNames(0,10) ""
	set ViewResultsBarBitmapsCommands(0,10) ""
	set ViewResultsBarBitmapsNames(0,11) ""
	set ViewResultsBarBitmapsCommands(0,11) ""
	set ViewResultsBarBitmapsNames(0,12) ""
	set ViewResultsBarBitmapsCommands(0,12) ""
	set ViewResultsBarBitmapsNames(0,14) ""
	set ViewResultsBarBitmapsCommands(0,14) ""
	set ViewResultsBarBitmapsNames(0,15) ""
	set ViewResultsBarBitmapsCommands(0,15) ""
	set ViewResultsBarBitmapsNames(0,16) ""
	set ViewResultsBarBitmapsCommands(0,16) ""
	set ViewResultsBarBitmapsNames(0,17) ""
	set ViewResultsBarBitmapsCommands(0,17) ""

    }

    CreateOtherBitmaps ViewResultsBar [_ "View Results bar"] ViewResultsBarBitmapsNames \
	ViewResultsBarBitmapsCommands ViewResultsBarBitmapsHelp $GIDDEFAULT/bitmaps ViewResultsBarBitmaps $what Post
    AddNewToolbar "View results bar" ViewResultsBarWindowGeom ViewResultsBarBitmaps [_ "View results bar"]

    
}
