#   root     is the parent window for this user interface

proc ActualizaSpacingYCentro { que_eje} {
    if { [ info exists ::ChangeVarInfo(Grid,Validando)] &&
	 $::ChangeVarInfo(Grid,Validando)} { return 1}
    set ::ChangeVarInfo(Grid,Validando) 1
    switch [ string tolower $que_eje] {
	"x" {
	    if { ( "$::ChangeVarInfo(Grid,MenosX)" != "") && 
		 ( "$::ChangeVarInfo(Grid,MasX)" != "") } {
		set err [ catch {
		    set diff [ expr $::ChangeVarInfo(Grid,MasX) - $::ChangeVarInfo(Grid,MenosX)]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,ExtentsX) $diff
		}
		set err [ catch {
		    set centX [ expr 0.5 * ( $::ChangeVarInfo(Grid,MasX) + $::ChangeVarInfo(Grid,MenosX))]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,CenterX) $centX
		}
	    }
	}
	"y" {
	    if { ( "$::ChangeVarInfo(Grid,MenosY)" != "") && 
		 ( "$::ChangeVarInfo(Grid,MasY)" != "") } {
		set err [ catch {
		    set diff [ expr $::ChangeVarInfo(Grid,MasY) - $::ChangeVarInfo(Grid,MenosY)]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,ExtentsY) $diff
		}
		set err [ catch {
		    set centY [ expr 0.5 * ( $::ChangeVarInfo(Grid,MasY) + $::ChangeVarInfo(Grid,MenosY))]
		}]
		if { !$err} {
		    set ::ChangeVarInfo(Grid,CenterY) $centY
		}
	    }
	}
    } 
    set ::ChangeVarInfo(Grid,Validando) 0
    return 1
}

proc ActualizaCaja { que_eje} {
    if { [ info exists ::ChangeVarInfo(Grid,Validando)] &&
	 $::ChangeVarInfo(Grid,Validando)} { return 1}
    switch [ string tolower $que_eje] {
	"x" {
	    set err [ catch {
		set menosX [ expr $::ChangeVarInfo(Grid,CenterX) - 0.5 * $::ChangeVarInfo(Grid,ExtentsX)]
		set masX [ expr $::ChangeVarInfo(Grid,CenterX) + 0.5 * $::ChangeVarInfo(Grid,ExtentsX)]
	    }]
	    if { !$err} {
		set ::ChangeVarInfo(Grid,MenosX) $menosX
		set ::ChangeVarInfo(Grid,MasX) $masX
	    }
	}
	"y" {
	    set err [ catch {
		set menosY [ expr $::ChangeVarInfo(Grid,CenterY) - 0.5 * $::ChangeVarInfo(Grid,ExtentsY)]
		set masY [ expr $::ChangeVarInfo(Grid,CenterY) + 0.5 * $::ChangeVarInfo(Grid,ExtentsY)]
	    }]
	    if { !$err} {
		set ::ChangeVarInfo(Grid,MenosY) $menosY
		set ::ChangeVarInfo(Grid,MasY) $masY
	    }
	}
    }
    set ::ChangeVarInfo(Grid,Validando) 0
    return 1
}

proc pref_grid_ui {root args} {
    global ChangeVarInfo
    set base $root
   
    frame $base.frame1 -borderwidth 2 -relief ridge
    frame $base.frame2 -borderwidth 2 -relief ridge
    frame $base.frame3 -borderwidth 2 -relief ridge
    frame $base.frame4 -borderwidth 2 -relief ridge
    
    checkbutton $base.frame1.cb1 -disabledforeground grey60 \
	    -text [_ "Show grid lines"] -variable ChangeVarInfo(Grid,Show) -justify left
    GidHelp $base.frame1.cb1 [_ "Show or hide the auxiliary grid lines."]
    checkbutton $base.frame1.cb11 -disabledforeground grey60 \
	    -text [_ "Show labels"] -variable ChangeVarInfo(Grid,DrawLabels) -justify left
    GidHelp $base.frame1.cb11 [_ "Show or hide the labels of the major lines"]
    checkbutton $base.frame1.cb2 -disabledforeground grey60 \
	    -text [_ "Activate snap"] -variable ChangeVarInfo(Grid,Active) -justify left
    GidHelp $base.frame1.cb2 \
	    [_ "Activate/deactivate snap that restricts cursor movement to the specified intervals."]

    label $base.frame2.l1 -text [_ "X Spacing"]:
    entry $base.frame2.e1 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,SpacingX) -width 8
    label $base.frame2.l2 -text [_ "Y Spacing"]:
    entry $base.frame2.e2 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,SpacingY) -width 8
    GidHelp $base.frame2 [_ "Distance between grid lines."]
    label $base.frame2.l3 -text [_ "Major line every"]:
    spinbox $base.frame2.sb1 -from 0 -to 100 -increment 1 -width 8 \
	-textvariable ChangeVarInfo(Grid,MajorLineEvery)
   
    label $base.frame3.l1 -text [_ "X Extents"]:
    entry $base.frame3.e1 -borderwidth 1 -insertborderwidth 1 \
	-textvariable ChangeVarInfo(Grid,ExtentsX) -width 8 \
	-validate focusout -validatecommand "ActualizaCaja x"
    label $base.frame3.l2 -text [_ "Y Extents"]:
    entry $base.frame3.e2 -borderwidth 1 -insertborderwidth 1 \
	-textvariable ChangeVarInfo(Grid,ExtentsY) -width 8 \
	-validate focusout -validatecommand "ActualizaCaja y"
    GidHelp $base.frame3 [_ "Dimensions of grid to be drawn."]
    
    checkbutton $base.frame4.cb1 -disabledforeground grey60 \
	    -text [_ "Draw axis"] -variable ChangeVarInfo(Grid,DrawAxis) -justify left
    label $base.frame4.l1 -text [_ "X Center"]:
    entry $base.frame4.e1 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,CenterX) -width 8 \
	-validate focusout -validatecommand "ActualizaCaja x"
    label $base.frame4.l2 -text [_ "Y Center"]:
    entry $base.frame4.e2 -borderwidth 1 -insertborderwidth 1 \
	    -textvariable ChangeVarInfo(Grid,CenterY) -width 8 \
	-validate focusout -validatecommand "ActualizaCaja y"
    GidHelp $base.frame4 [_ "grid center to be drawn."]

    frame $base.frame1.fcaja -bd 2 -relief groove
    label $base.frame1.fcaja.l1 -text [_ "From X"]
    entry $base.frame1.fcaja.e1 -width 8 -textvariable ::ChangeVarInfo(Grid,MenosX) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro x"
    label $base.frame1.fcaja.l2 -text [_ "to X"]
    entry $base.frame1.fcaja.e2 -width 8 -textvariable ::ChangeVarInfo(Grid,MasX) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro x"
    label $base.frame1.fcaja.l3 -text [_ "From Y"]
    entry $base.frame1.fcaja.e3 -width 8 -textvariable ::ChangeVarInfo(Grid,MenosY) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro y"
    label $base.frame1.fcaja.l4 -text [_ "to Y"]
    entry $base.frame1.fcaja.e4 -width 8 -textvariable ::ChangeVarInfo(Grid,MasY) \
	-validate focusout -validatecommand "ActualizaSpacingYCentro y"

    grid $base.frame1.fcaja.l1 $base.frame1.fcaja.e1 $base.frame1.fcaja.l2 $base.frame1.fcaja.e2 -padx 2 -pady 1
    grid $base.frame1.fcaja.l3 $base.frame1.fcaja.e3 $base.frame1.fcaja.l4 $base.frame1.fcaja.e4 -padx 2 -pady 1

    grid $base.frame1 -in $root -sticky nsew -padx 6
    grid $base.frame1.cb1 $base.frame1.cb11 -sticky w
    grid $base.frame1.cb2 -sticky w -columnspan 2
    grid $base.frame2 -in $root.frame1 -columnspan 2 -sticky nsew -padx 6 
    grid $base.frame3 -in $root.frame1 -columnspan 2 -sticky nsew -padx 6 
    grid $base.frame4 -in $root.frame1 -columnspan 2 -sticky nsew -padx 6
    grid $base.frame1.fcaja -sticky news -columnspan 2 -sticky nsew -padx 2 -pady 1

    grid $base.frame2.l1 $base.frame2.e1 -sticky w -padx 4 -pady 3
    grid $base.frame2.l2 $base.frame2.e2 -sticky w -padx 4 -pady 3
    grid $base.frame2.l3 $base.frame2.sb1 -sticky w -padx 4 -pady 3
    grid configure $base.frame2.e1 $base.frame2.e2 $base.frame2.sb1 -sticky ew

    grid $base.frame3.l1 $base.frame3.e1 -sticky w -padx 4 -pady 3
    grid $base.frame3.l2 $base.frame3.e2 -sticky w -padx 4 -pady 3
    grid configure $base.frame3.e1 $base.frame3.e2 -sticky ew

    grid $base.frame4.cb1 -sticky w -columnspan 2
    grid $base.frame4.l1 $base.frame4.e1 -sticky w -padx 4 -pady 3
    grid $base.frame4.l2 $base.frame4.e2 -sticky w -padx 4 -pady 3
    grid configure $base.frame4.e1 $base.frame4.e2 -sticky ew    

    grid rowconfigure $root {4} -weight 1 -minsize 2
    grid columnconfigure $root 0 -weight 1 -minsize 170
    
    grid rowconfigure $base.frame1 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame1 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame1 1 -weight 1 -minsize 2
    
    grid rowconfigure $base.frame2 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame2 {0 1} -weight 1 -minsize 2
    
    grid rowconfigure $base.frame3 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame3 {0 1} -weight 1 -minsize 2

    grid rowconfigure $base.frame4 0 -weight 1 -minsize 2
    grid columnconfigure $base.frame4 {0 1} -weight 1 -minsize 2
}
