#! /bin/sh
# the next line restarts using wish8.0 \
exec wish8.0 "$0" "$@"

# interface generated by SpecTcl version 1.1 from /usr2/people/ramsan/bin/specsamples/pref_meshing.ui
#   root     is the parent window for this user interface


proc ChangeGrowLaw { args } {
    global ChangeVarInfo
    set canvas $::BaseLocalMeshing.canvas#1
    set spinbox $::BaseLocalMeshing.spinbox#1
    if { ![winfo exists $spinbox] } return
    switch $ChangeVarInfo(BoundaryLayer,GrowLaw) {
	0 {
	    $spinbox configure -from 1.0
	    set ChangeVarInfo(BoundaryLayer,GrowFactor) 2.0
	    GidHelp $::BaseLocalMeshing.menubutton#30 [_ "This function is the geometric progression, represented by: h_i = h_0*(r^0+r^1+r^2++r^(i-1)\
		    , where 'h_i' is the height at level 'i' and 'r' is the grow factor"]
	}
	1 {
	    $spinbox configure -from 0.1
	    set ChangeVarInfo(BoundaryLayer,GrowFactor) 1.0
	    GidHelp $::BaseLocalMeshing.menubutton#30 [_ "This function exponential, represented by: h_i = exp(r*i + ln(h_0))\
		    , where 'h_i' is the height at level 'i' and 'r' is the grow factor."]
	}
	2 {
	    $spinbox configure -from 0.1
	    set ChangeVarInfo(BoundaryLayer,GrowFactor) 1.0
	    GidHelp $::BaseLocalMeshing.menubutton#30 [_ "This function is represented by: h_i = h_0 * (1 + i*(1+r*(1+r)*i)))\
		    , where 'h_i' is the height at level 'i' and 'r' is the grow factor. This function typically grows faster\
		    than the Geometric one."]
	}
    }
    
    RedrawDivisions_blm $canvas
}

proc ChangeGrowFactor { args } {
    global ChangeVarInfo
    set canvas $::BaseLocalMeshing.canvas#1
    set spinbox $::BaseLocalMeshing.spinbox#1
    if { ![winfo exists $spinbox] } return
    switch $ChangeVarInfo(BoundaryLayer,GrowLaw) {
	0 {
	    if { $ChangeVarInfo(BoundaryLayer,GrowFactor) < 1 } {
		$spinbox configure -background red
		$canvas delete temp   
		return
	    }            
	}
	1 {
	    if { $ChangeVarInfo(BoundaryLayer,GrowFactor) <= 0 } {
		$spinbox configure -background red
		$canvas delete temp   
		return
	    }            
	}
	2 {
	    if { $ChangeVarInfo(BoundaryLayer,GrowFactor) <= 0 } {
		$spinbox configure -background red
		$canvas delete temp   
		return
	    }            
	}
    }    
    $spinbox configure -background white    
   
    RedrawDivisions_blm $canvas    
}

proc RedrawDivisions_blm { canvas args} {
    if { ![winfo exists $canvas] } { 
	return
    }
    
    
    global ChangeVarInfo

    $canvas delete temp
    set maxwidth 300
  
    
    #First distance = 4 pixel
    set DistanceFirst 4
    
    set layerX [expr 2+$DistanceFirst]
    switch $ChangeVarInfo(BoundaryLayer,GrowLaw) {
	0 {            
	    #geometric
	    set i 1
	    while { $layerX<$maxwidth } {  
		$canvas create line $layerX 0 $layerX 8 -fill black -width 1  -tags temp 
		if { $ChangeVarInfo(BoundaryLayer,GrowFactor) == 1 } {
		    set layerX [expr 2+round($DistanceFirst*($i+1)*$ChangeVarInfo(BoundaryLayer,GrowFactor))]
		} else {
		    set layerX [expr 2+round($DistanceFirst*(1-pow($ChangeVarInfo(BoundaryLayer,GrowFactor),$i+1))/(1-$ChangeVarInfo(BoundaryLayer,GrowFactor)))]
		}
		incr i
	    }
	}
	1 {
	    #exponential
	    set i 1
	    while { $layerX<$maxwidth } {
		$canvas create line $layerX 0 $layerX 8 -fill black -width 1  -tags temp 
		set layerX [expr 2+round(exp(log($DistanceFirst)+($ChangeVarInfo(BoundaryLayer,GrowFactor)*$i)))]
		incr i
	    }
	}
	2 {
	    #geometric_mod
	    set i 1
	    while { $layerX<$maxwidth } {
		$canvas create line $layerX 0 $layerX 8 -fill black -width 1  -tags temp 
		set layerX [expr 2+round($DistanceFirst*(1+$i*(1+$ChangeVarInfo(BoundaryLayer,GrowFactor)*(1+$ChangeVarInfo(BoundaryLayer,GrowFactor))*$i)))]
		incr i
	    }
	}
    }
    
}
proc pref_meshing_ui {root args} {
    
    # this treats "." as a special case
    global GidPriv ChangeVarInfo BaseLocalMeshing
    
    #set growlaw [GiD_Set BoundaryLayer(GrowLaw)]
    #set growfactor [GiD_Set BoundaryLayer(GrowFactor)]

    
    if {$root == "."} {
	set base ""
    } else {
	set base $root
    }
    set ::BaseLocalMeshing $base
    
    labelframe $base.frame#2 \
	-borderwidth 2 \
	-relief ridge \
	-text [_ "Surface mesher"]
    
    labelframe $base.frame#4 \
	-borderwidth 2 \
	-relief ridge \
	-text [_ "Automatic correct sizes"]
    
    labelframe $base.frame#1 -borderwidth 1 -relief ridge -text [_ "Unstructured size transitions"] -pady 1
    
#     labelframe $base.frame#8 \
#         -borderwidth 2 \
#         -relief ridge \
#         -text [_ "Chordal error"]

    labelframe $base.frame#3 \
	-borderwidth 2 \
	-relief ridge \
	-text [_ "Structured mesh"]
    
    labelframe $base.frame#5 \
	-borderwidth 2 \
	-relief ridge \
	-text [_ "Others"]
    
    if { $::BOUNDARY_LAYER_MESH } {
	labelframe $base.frame#10 \
	    -borderwidth 2 \
	    -relief ridge \
	    -text [_ "Boundary Layer Mesh"]
    }
    
    
    radiobutton $base.radiobutton#1 \
	-text [_ "RFast"] \
	-variable ChangeVarInfo(SurfaceMesher) -value 0
    
    radiobutton $base.radiobutton#2 \
	-text [_ "RSurf"] \
	-variable ChangeVarInfo(SurfaceMesher) -value 1
    
    #radiobutton $base.radiobutton#3 \
	#-text [_ "2Dumg"] \
	#-variable ChangeVarInfo(SurfaceMesher) -value 2
    
    radiobutton $base.radiobutton#4 \
	-text [_ "RJump"] \
	-variable ChangeVarInfo(SurfaceMesher) -value 4
	    
    GidHelp "$base.frame#2 $base.radiobutton#1 \
	$base.radiobutton#2 $base.radiobutton#4 " \
	[_ "Surface meshers can be:\
	    \n'Rfast': The most efficient in speed and reliability. With\
	    deformed surfaces can give distorted elements.\
	    \n'Rsurf': Meshes are generated directly in the space.\
	    Quality is better but it is slower and can fail for distorted\
	    surfaces.\
	    \n'Rjump': Meshes are generated directly in the space, but trying to jump the lines between surfaces."]
    
    
    frame $base.frame#20
    checkbutton $base.checkbutton#11 \
	-text [_ "Maximum chordal error in model (%):"] \
	-disabledforeground grey60 \
	-variable ChangeVarInfo(ChordalError,ApplyChordalErrorToModel)
    
    entry $base.entry#10 \
	-borderwidth 1 \
	-cursor {} \
	-insertborderwidth 1 \
	-textvariable ChangeVarInfo(ChordalError,RelativeChordalError) \
	-width 5
    GidHelp "$base.frame#8 $base.checkbutton#11 \
	$base.entry#10 " \
	[_ "This criteria is applied to all the model mesh, and tends \
	    \nto adapt element sizes to avoid the existence of elements \
	    with more chordal error than the one specified.\
	    \nThe value is a relative value in %, refered to \
	    \nthe mean size of the element."]
    
    checkbutton $base.checkbutton#1 \
	-text [_ "Mesh until end"] \
	-variable ChangeVarInfo(MeshUntilEnd)
    
    GidHelp $base.checkbutton#1 [_ "If this preference is set, the mesh\
	    generator will continue until end although there are surfaces\
	    or volumes that cannot be meshed."]
	
    radiobutton $base.radiobutton#6 -text [_ "None#C#AutomaticCorrectSizes"]   -variable ChangeVarInfo(AutomaticCorrectSizes) -value 0
    radiobutton $base.radiobutton#7 -text [_ "Normal"] -variable ChangeVarInfo(AutomaticCorrectSizes) -value 1
    radiobutton $base.radiobutton#8 -text [_ "Hard#C#AutomaticCorrectSizes"]   -variable ChangeVarInfo(AutomaticCorrectSizes) -value 2
    
    GidHelp "$base.frame#4 $base.radiobutton#6 $base.radiobutton#7 $base.radiobutton#8 " \
	[_ "This preference let GiD to make an automatic mesh sizes correction when meshing begins. \
	    If None is set, no sizes correction is made; if Normal is set, a sizes correction is made, according to \
	    the geometrical entities sizes, and to the compatibility between meshing sizes of neighbour entities; \
	    if Hard is set, the Normal correction is made and, furthermore, an automatic chordal error is \
	    applied to assign sizes to surfaces which are contour of volumes, so as to improve volume meshes."]
    
    
    button $base.button#4 \
	-command {set ChangeVarInfo(SizeTransitions) [expr $ChangeVarInfo(SizeTransitions)-0.1]} \
	-disabledforeground grey60 \
	-text -
#     label makes too height in the frame
#     scale $base.scale#4 \
#         -highlightbackground black \
#         -label [_ "slower"] \
#         -length 1 \
#         -orient h \
#         -resolution 0.1 \
#         -to 1.0 \
#         -variable ChangeVarInfo(SizeTransitions) \
#          -width 16
	 scale $base.scale#4 \
	 -highlightbackground black \
	 -length 1 \
	 -orient h \
	 -resolution 0.1 \
	 -to 1.0 \
	 -variable ChangeVarInfo(SizeTransitions) \
	  -width 16

    button $base.button#3 \
	-command {set ChangeVarInfo(SizeTransitions) [expr $ChangeVarInfo(SizeTransitions)+0.1]} \
	-disabledforeground grey60 \
	-text +
    
    #GidHelp "$base.frame#1 $base.label#4 $base.button#4 $base.scale#4 \

    GidHelp "$base.frame#1 $base.button#4 $base.scale#4 \
	$base.button#3" [_ "It controls whether the transitions between\
	    different element sizes are slow (near to 0) or fast (near to 1)."]
    
    checkbutton $base.checkbutton#12 \
	-text [_ "Regular transition near boundary"] \
	-variable ChangeVarInfo(BoundaryWeightedTransition) -pady 1
    GidHelp $base.checkbutton#12 [_ "If this preference is set, sizes transition in unstructured\
	    mesh will be boundary weighted. Otherwise will be a more uniform sizes transition. "]
    
    if { $::BOUNDARY_LAYER_MESH } {
	checkbutton $base.checkbutton#15 \
	    -text [_ "Boundary layer mesh in separated Layer"] \
	    -variable ChangeVarInfo(BoundaryLayer,MeshInSpecificLayer)

	GidHelp $base.checkbutton#15 [_ "If this preference is set, the nodes and elements of boundary layer mesh\
		will own to new Layers. These new Layers will have BLM_ as a prefix. "]

	frame $base.frame#25
	label $base.label#10 -text [_ "Stretching function:"]

	ComboBoxRAM $base.menubutton#30 ChangeVarInfo(BoundaryLayer,GrowLaw) \
	    [list [_ "Function 1 (Geometric)"] [_ "Function 2 (Exponential)"] [_ "Function 3"]] {"0" "1" "2"}
    
	label $base.label#30 -text [_ "Grow factor:"]
	spinbox $base.spinbox#1 -from 0 -to 1000 -increment 0.1 -width 6 \
	    -textvariable ChangeVarInfo(BoundaryLayer,GrowFactor)
	#$base.spinbox#1 configure -text [format "%.2f" [GiD_Set BoundaryLayer(GrowFactor)]] 
	GidHelp $base.spinbox#1 [_ "Factor applied to compute the layers"]
	
	

	canvas $base.canvas#1 -height 7 -width 300
      
	
	$base.canvas#1 create line 2 5 250 5 -fill red -width 2
	$base.canvas#1 create line 255 5 260 5 -fill red -width 2
	$base.canvas#1 create line 265 5 270 5 -fill red -width 2
	$base.canvas#1 create line 275 5 277 5 -fill red -width 2
	$base.canvas#1 create line 284 5 286 5 -fill red -width 2
	$base.canvas#1 create line 2 0 2 8 -fill black -width 1 

	#ChangeGrowLaw
	#ChangeGrowFactor
	
    }
    
    checkbutton $base.checkbutton#3 \
	-text [_ "No mesh frozen layers"] \
	-variable ChangeVarInfo(NoMeshFrozenLayers)
    
    GidHelp $base.checkbutton#3 [_ "If this preference is set, no mesh will\
	    be generated over entities that belong to frozen layers. "]
    
    checkbutton $base.checkbutton#4 \
	-text [_ "Allow automatic structured"] \
	-variable ChangeVarInfo(AllowAutomaticStructured)
    
    GidHelp $base.checkbutton#4 [_ "If this preference is set, functions\
	    like 'Assign sizes by Chordal Error' will define some surfaces\
	    as structured with highly distorted elements over them."]
    
    label $base.label#70 \
	-text [_ "Symmetrical structured: "]

    checkbutton $base.checkbutton#8 \
	-text [_ "triangles"] \
	-variable ChangeVarInfo(SymmetricalStructuredTriangles)
    
    GidHelp $base.checkbutton#8 [_ "If this preference is set, structured\
	    triangles meshes will be topologically symmetrical. \
	    Four triangles will be created from each quadrilateral"]
    

    checkbutton $base.checkbutton#9 \
	-text [_ "tetrahedra"] \
	-variable ChangeVarInfo(SymmetricalStructuredTetrahedra)

    GidHelp $base.checkbutton#9 [_ "If this preference is set, structured\
		tetrahedra meshes will be topologically symmetrical. \
		Twenty four tetrahedra will be created from each hexahedron"]
    
    frame $base.frame#6
    
    label $base.label#7 \
	-text [_ "Mesh always by default:"]
    # -wraplength 20m -justify left
    
    set pp [ $base cget -background]
    
    checkbutton $base.checkbutton#5 \
	-disabledforeground grey60 \
	-image [GetImage "point16x16.gif"] \
	-indicatoron 0 \
	-variable ChangeVarInfo(ForceMeshPoints) -bd 1 -selectcolor $pp        
    
    checkbutton $base.checkbutton#6 \
	-disabledforeground grey60 \
	-image [GetImage "line16x16.gif"] \
	-indicatoron 0 \
	-variable ChangeVarInfo(ForceMeshLines) -bd 1 -selectcolor $pp
    
    checkbutton $base.checkbutton#7 \
	-disabledforeground grey60 \
	-image [GetImage "coonsurf16x16.gif"] \
	-indicatoron 0 \
	-variable ChangeVarInfo(ForceMeshSurfaces) -bd 1 -selectcolor $pp
    
    GidHelp "$base.label#7 $base.checkbutton#5 $base.checkbutton#6 $base.checkbutton#7" \
	[_ "Changes the default meshing criteria. Entities will be always\
	    meshed by default, although they have higher entities over them.\nExample:\
	    If surfaces are checked, when meshing a volume, both volume elements and\
	    surface elements will be obtained."]
    
    frame $base.frame#7
    label $base.label#8 \
	-text [_ "Smoothing:"] -width 10 -justify left
    ComboBoxRAM $base.menubutton#1 ChangeVarInfo(HighQualitySmoothing) \
	[list [_ "Normal"] [_ "HighAngle"] [_ "HighGeom"]] \
	{"Normal" "HighAngle" "HighGeom"} 
    
    GidHelp  "$base.label#8 $base.menubutton#1" [_ "Options for smoothing in order to enhance\
	    the mesh after the generation. Options are:\
	    \nNormal: only the standard smooth is performed\
	    \nHighAngle: an additional smooth with angle criteria is performed\
	    \nHighGeom: an additional smooth with chordal error criteria is performed"]
    
    checkbutton $base.checkbutton#10 \
	-text [_ "Avoid elements with all its nodes in boundary"] \
	-variable ChangeVarInfo(AvoidElementsInBoundary)
    
    GidHelp $base.checkbutton#10 [_ "If this preference is set, the mesh won't have\
	    linear elements with all its nodes in boundary."]
    


    # Geometry management
    
    grid $base.frame#2 -in $root    -row 1 -column 1 -sticky nesw -padx 6 -pady 3
    grid $base.frame#4 -in $root    -row 2 -column 1 -sticky nesw -padx 6 -pady 3
    grid $base.frame#1 -in $root    -row 3 -column 1 -sticky nesw -padx 6 -pady 1
    #     grid $base.frame#8 -in $root    -row 4 -column 1 -sticky nesw -padx 6 -pady 3
    grid $base.frame#3 -in $root    -row 4 -column 1 -sticky nesw -padx 6 -pady 3
    if { $::BOUNDARY_LAYER_MESH } {
	grid $base.frame#10 -in $root   -row 5 -column 1 -sticky nesw -padx 6 -pady 3
	grid $base.frame#5 -in $root    -row 6 -column 1 -sticky nesw -padx 6 -pady 3
    } else {
	grid $base.frame#5 -in $root    -row 5 -column 1 -sticky nesw -padx 6 -pady 3
    }

    grid $base.radiobutton#1 -in $base.frame#2        -row 1 -column 1 
    grid $base.radiobutton#2 -in $base.frame#2        -row 1 -column 2 
    #grid $base.radiobutton#3 -in $base.frame#2        -row 2 -column 3 
    grid $base.radiobutton#4 -in $base.frame#2        -row 1 -column 3 
    
#     grid $base.checkbutton#11 -in $base.frame#8 -row 1 -column 1  -pady 10 -sticky ew
#     grid $base.entry#10 -in $base.frame#8 -row 1 -column 2  -pady 10 -sticky ew
    grid $base.checkbutton#11 -in $base.frame#20 -row 0 -column 1  -pady 3 -sticky nw
    grid $base.entry#10 -in $base.frame#20 -row 0 -column 2  -pady 3 -sticky nw
    
    if { $::BOUNDARY_LAYER_MESH } {
	grid $base.frame#25 -in $base.frame#10 -row 0 -column 1  -padx 0 -pady 5 -sticky news
	grid $base.checkbutton#15 -in $base.frame#10 -row 1 -column 1  -padx 0 -pady 3 -sticky nw
      
	grid $base.label#10 -in $base.frame#25 -row 0 -column 0  -padx 0 -pady 3 -sticky w
	grid $base.menubutton#30 -in $base.frame#25 -row 0 -column 1  -padx 5 -pady 3 -sticky w
	grid $base.label#30 -in $base.frame#25 -row 0 -column 2  -padx 3 -pady 3 -sticky w
	grid $base.spinbox#1 -in $base.frame#25 -row 0 -column 3  -padx 3 -pady 3 -sticky nsw        
	grid $base.canvas#1 -in $base.frame#25 -row 1 -column 0  -padx 0 -pady 5 -sticky nesw -columnspan 4
    }
    
    grid $base.button#4 -in $base.frame#1         -row 1 -column 1  -pady 10
    grid $base.scale#4  -in $base.frame#1         -row 1 -column 2  -pady 5  -sticky nesw        
    grid $base.button#3 -in $base.frame#1         -row 1 -column 3  -pady 10
    grid $base.checkbutton#12 -in $base.frame#1   -row 2 -column 2  -pady 1  -sticky nesw    
    
    grid $base.checkbutton#1 -in $base.frame#5 -row 1 -column 1 -sticky nw
    grid $base.checkbutton#3 -in $base.frame#5 -row 2 -column 1 -sticky nw
    grid $base.checkbutton#10 -in $base.frame#5 -row 3 -column 1 -sticky nw

    grid $base.radiobutton#6 -in $base.frame#4  -row 1 -column 0 
    grid $base.radiobutton#7 -in $base.frame#4  -row 1 -column 1 
    grid $base.radiobutton#8 -in $base.frame#4  -row 1 -column 2 

    grid $base.checkbutton#4 -in $base.frame#3 -sticky w -columnspan 3
    grid $base.label#70 -in $base.frame#3 -sticky w -row 1 -columnspan 1 -column 0
    grid $base.checkbutton#8 -in $base.frame#3 -sticky w -row 1 -columnspan 1 -column 1
    grid $base.checkbutton#9 -in $base.frame#3 -sticky w -row 1 -columnspan 1 -column 2
    
    grid $base.frame#6 -in $base.frame#5 -row 5 -column 1 -sticky nw -padx 3 -pady 3
    grid $base.label#7 -in $base.frame#6 -row 1 -column 1 -sticky nw -padx 3 -pady 3
    grid $base.checkbutton#5 -in $base.frame#6 -row 1 -column 2 -sticky nw -padx 2 -pady 3
    grid $base.checkbutton#6 -in $base.frame#6 -row 1 -column 3 -sticky nw -padx 2 -pady 3
    grid $base.checkbutton#7 -in $base.frame#6 -row 1 -column 4 -sticky nw -padx 2 -pady 3
    
    grid $base.frame#7 -in $base.frame#5 -row 0 -column 1 -sticky nesw -padx 6 -pady 3
    grid $base.label#8 -in $base.frame#7 -row 1 -column 1 -sticky w -padx 3 -pady 3
    grid $base.menubutton#1 -in $base.frame#7 -row 1 -column 2 -sticky w -padx 3 -pady 3
    
    grid $base.frame#20 -in $base.frame#5 -row 4 -column 1 -sticky nw -padx 0 -pady 3

    # Resize behavior management
    
    grid rowconfigure $base.frame#2 1 -weight 0 -minsize 2
    #grid rowconfigure $base.frame#2 2 -weight 0 -minsize 2
    grid columnconfigure $base.frame#2 1 -weight 0
    grid columnconfigure $base.frame#2 2 -weight 0
    grid columnconfigure $base.frame#2 3 -weight 0
    grid columnconfigure $base.frame#2 4 -weight 0
    
    grid rowconfigure $base.frame#4 0 -weight 0 -minsize 2
    #grid rowconfigure $base.frame#4 2 -weight 0 -minsize 2
    #grid columnconfigure $base.frame#4 1 -weight 1 -minsize 2
    #grid columnconfigure $base.frame#4 2 -weight 0 -minsize 2

    grid columnconfigure $base.frame#3 0 -weight 0 
#     grid columnconfigure $base.frame#3 1 -weight 1 
    
    if { $::BOUNDARY_LAYER_MESH } {
	grid columnconfigure $base.frame#10 0 -weight 0 
	grid columnconfigure $base.frame#10 1 -weight 1 
	grid rowconfigure $base.frame#10 1 -weight 1 -minsize 2
	
	grid rowconfigure $base.frame#25 0 -weight 0
	grid rowconfigure $base.frame#25 1 -weight 0
	grid rowconfigure $base.frame#25 2 -weight 0
	
	grid columnconfigure $base.frame#25 0 -weight 0
	grid columnconfigure $base.frame#25 1 -weight 0
	grid columnconfigure $base.frame#25 2 -weight 0
	
    }
    
    grid rowconfigure $base.frame#5 1 -weight 0 -minsize 2
    grid rowconfigure $base.frame#5 2 -weight 0 -minsize 2
    grid rowconfigure $base.frame#5 3 -weight 0 -minsize 2
    grid rowconfigure $base.frame#5 4 -weight 0 -minsize 2
    grid columnconfigure $base.frame#5 1 -weight 1 -minsize 2
    grid columnconfigure $base.frame#5 2 -weight 0 -minsize 2
    
    grid columnconfigure $base.frame#7 1 -weight 0 -minsize 30
    grid columnconfigure $base.frame#7 2 -weight 0 -minsize 30
    
    #grid rowconfigure $root "1 2 3 4 5" -weight 0  -minsize 2
     if { $::BOUNDARY_LAYER_MESH } {
	grid rowconfigure $root 6 -weight 1
     } else {
	   grid rowconfigure $root 5 -weight 1 
     }
    grid columnconfigure $root 1 -weight 1 -minsize 2
    
    grid rowconfigure $base.frame#1 1 -weight 0 
    grid rowconfigure $base.frame#1 2 -weight 0 -minsize 2
    grid rowconfigure $base.frame#1 3 -weight 1 -minsize 2
    grid columnconfigure $base.frame#1 1 -weight 0 -minsize 13
    grid columnconfigure $base.frame#1 2 -weight 1 -minsize 2
    grid columnconfigure $base.frame#1 3 -weight 0 -minsize 2
    # additional interface code
    
    # end additional interface code
    if { $::BOUNDARY_LAYER_MESH } {
	trace add variable ChangeVarInfo(BoundaryLayer,GrowFactor) write "ChangeGrowFactor"            
	
	trace add variable ChangeVarInfo(BoundaryLayer,GrowLaw) write "ChangeGrowLaw"
	
    }
}


# Allow interface to be run "stand-alone" for testing

catch {
    if [info exists embed_args] {
	# we are running in the plugin
	pref_meshing_ui .
    } else {
	# we are running in stand-alone mode
	if {$argv0 == [info script]} {
	    wm title . [_ "Testing pref_meshing_ui"]
	    pref_meshing_ui .
	}
    }
}

